#!/bin/bash

function on_die()
{
    # print message
    #
    echo "Dying..."

    # Need to exit the script explicitly when done.
    # Otherwise the script would live on, until system
    # realy goes down, and KILL signals are send.
    #
    WPID=`pidof tvtime-scanner`
    kill -9 $WPID
    exit 0
}

# Execute function on_die() receiving TERM signal
#
trap on_die SIGTERM

cp /netpulse/etc/stationlist.xml.default /netpulse/etc/stationlist.xml

DEVICE_TYPE=`/netpulse/bin/n5i-sys which-tv-device`
if [ "$DEVICE_TYPE" == "HVR900H" ]; then
    # The driver for this tuner does not support signal detection, so we can't 
    # scan for channels.
    # /netpulse/bin/tvtime-scanner -n pal -F /netpulse/etc/PALtvtime.xml &
    exit 0;
else
    /netpulse/bin/tvtime-scanner -n ntsc -F /netpulse/etc/tvtime.xml -e $1 &
fi

SERVICE='tvtime-scanner'
RUNNING=`ps ax | grep -v grep | grep $SERVICE`
while [ "$RUNNING" != "" ] ; do
  sleep 1
  RUNNING=`ps ax | grep -v grep | grep $SERVICE`
done

echo "Scanning complete"
