////////////////////////////////////////////////////////////////////////////////
//
// The gui application will call functions in this object.
//

var csafeHelperObj = new csafeHelper();

function csafeHelper() {
    this.callBackObjArray = new Array();

    // public properties
    this.LIFE_FITNESS_NUMERIC_KEYPAD_1       = 1;  // 0x01;
    this.LIFE_FITNESS_NUMERIC_KEYPAD_2       = 2;  // 0x02;
    this.LIFE_FITNESS_NUMERIC_KEYPAD_3       = 3;  // 0x03;
    this.LIFE_FITNESS_NUMERIC_KEYPAD_4       = 4;  // 0x04;
    this.LIFE_FITNESS_NUMERIC_KEYPAD_5       = 5;  // 0x05;
    this.LIFE_FITNESS_NUMERIC_KEYPAD_6       = 6;  // 0x06;
    this.LIFE_FITNESS_NUMERIC_KEYPAD_7       = 7;  // 0x07;
    this.LIFE_FITNESS_NUMERIC_KEYPAD_8       = 8;  // 0x08;
    this.LIFE_FITNESS_NUMERIC_KEYPAD_9       = 9;  // 0x09;
    this.LIFE_FITNESS_NUMERIC_KEYPAD_0       = 10; // 0x0A;
    this.LIFE_FITNESS_PREVIOUS_CHANNEL       = 11; // 0x0B;
    this.LIFE_FITNESS_TV_POWER               = 12; // 0x0C;
    this.LIFE_FITNESS_CHANNEL_UP             = 13; // 0x0D;
    this.LIFE_FITNESS_CHANNEL_DOWN           = 14; // 0x0E;
    this.LIFE_FITNESS_VOLUME_UP              = 15; // 0x0F;
    this.LIFE_FITNESS_VOLUME_DOWN            = 16; // 0x10;
    this.LIFE_FITNESS_PLAY_PAUSE             = 17; // 0x11;
    this.LIFE_FITNESS_SOURCE                 = 18; // 0x12;
    this.LIFE_FITNESS_MUTE                   = 19; // 0x13;
    this.LIFE_FITNESS_CLOSED_CAPTIONING      = 20; // 0x14;
    this.LIFE_FITNESS_NUMERIC_KEYPAD_ENTER   = 21; // 0x15;
    this.LIFE_FITNESS_NUMERIC_KEYPAD_DASH    = 22; // 0x16;
    this.LIFE_FITNESS_IPOD_VIDEO             = 23; // 0x17 Go to the iPod Video View
    this.LIFE_FITNESS_TV_VIDEO               = 24; // 0x18 Go to the TV View
    this.LIFE_FITNESS_WORKOUT_ACCEPTED       = 25; // 0x19 User accepted workout on LF console
    this.LIFE_FITNESS_WORKOUT_TIMEOUT        = 26; // 0x1A User did NOT accept workout on LF console
}

csafeHelper.prototype.setCallBack = function(apiName, cbFunc) {
    var bRet = false;
    try {
        if ("function" === typeof cbFunc) {
            this.callBackObjArray[apiName] = cbFunc;
            bRet = true;
        }
    }
    catch(e) {
        popError(e);
    }
    
    return bRet;
}

csafeHelper.prototype.cmdLFSetUserLanguageChangedEvent = function(nLanguageID) {
    writeLog("info", "csafeHelper.prototype.cmdLFSetUserLanguageChangedEvent("+nLanguageID+")");
    
    try {
        if ("function" === typeof this.callBackObjArray["cmdLFSetUserLanguageChangedEvent"])
            eval(this.callBackObjArray["cmdLFSetUserLanguageChangedEvent"](nLanguageID));
    }
    catch(e) {
        popError(e);
    }
}

csafeHelper.prototype.odometerChangedEvent = function(odometer, unitSpecifier) {
    writeLog("info", "csafeHelper.prototype.odometerChangedEvent("+odometer+", "+unitSpecifier+")");
    
    try {
        if ("function" === typeof this.callBackObjArray["odometerChangedEvent"])
            eval(this.callBackObjArray["odometerChangedEvent"](odometer, unitSpecifier));
    }
    catch(e) {
        popError(e);
    }
}

csafeHelper.prototype.utilizationChangedEvent = function(nhoursUsed) {
    writeLog("info", "csafeHelper.prototype.utilizationChangedEvent("+nhoursUsed+")");

    try {
        if ("function" === typeof this.callBackObjArray["utilizationChangedEvent"])
            eval(this.callBackObjArray["utilizationChangedEvent"](nhoursUsed));
    }
    catch(e) {
        popError(e);
    }
}

csafeHelper.prototype.versionChangedEvent = function(nManufacturer1, nCID, nModel, nVersion, nRelease) {
    writeLog("info", "csafeHelper.prototype.versionChangedEvent("+nManufacturer1+", "+nCID+", "+nModel+", "+nVersion+", "+nRelease+")");

    try {
        if ("function" === typeof this.callBackObjArray["versionChangedEvent"])
            eval(this.callBackObjArray["versionChangedEvent"](nManufacturer1, nCID, nModel, nVersion, nRelease));
    }
    catch(e) {
        popError(e);
    }
}

csafeHelper.prototype.cmdLFSendKeyChangedEvent = function(nKeyCode) {
    writeLog("info", "csafeHelper.prototype.cmdLFSendKeyChangedEvent("+nKeyCode+")");
    try {
        if ("function" === typeof this.callBackObjArray["cmdLFSendKeyChangedEvent"])
            eval(this.callBackObjArray["cmdLFSendKeyChangedEvent"](nKeyCode));
    }
    catch(e) {
        popError(e);
    }
}

csafeHelper.prototype.cmdTWorkChangeEvent = function(strTime) {
    writeLog("info", "csafeHelper.prototype.cmdTWorkChangeEvent("+strTime+")");
    try {
        if ("function" === typeof this.callBackObjArray["cmdTWorkChangeEvent"])
            eval(this.callBackObjArray["cmdTWorkChangeEvent"](strTime));
    }
    catch(e) {
        popError(e);
    }
}

csafeHelper.prototype.cmdProgramChangeEvent = function(nNewProgram, nPrevProgram, nLevel) {
    writeLog("info", "csafeHelper.prototype.cmdProgramChangeEvent("+nNewProgram+", "+ nPrevProgram +", "+ nLevel +")");
    try {
        if ("function" === typeof this.callBackObjArray["cmdProgramChangeEvent"])
            eval(this.callBackObjArray["cmdProgramChangeEvent"](nNewProgram, nPrevProgram, nLevel));
    }
    catch(e) {
        popError(e);
    }
}

//
////////////////////////////////////////////////////////////////////////////////

function getUnitString(nSpeedUnit) {
    var str;
    switch (eval(nSpeedUnit)) {
        case 3: {
            str = IDS_LANGUAGE["miles"];
            break;
        }
        case 16: /* CSAFE_UNIT_MPH */
        case 17: /* CSAFE_UNIT_TENTH_MPH */
        case 18: /* CSAFE_UNIT_HUNDREDTH_MPH */
        {
            str = IDS_LANGUAGE["mph"];
            break;
        }
        case 48: /* CSAFE_UNIT_KPH */
        case 49: /* CSAFE_UNIT_TENTH_KPH */
        case 50: /* CSAFE_UNIT_HUNDREDTH_KPH */
        {
            str = IDS_LANGUAGE["(km/h)"];
            break;
        }
        case 65: /*CSAFE_UNIT_FLOORS*/
        {
            str = IDS_LANGUAGE["Floors"];
            break;
        }
        case 66: /*CSAFE_UNIT_TENTH_FLOORS*/
        {
            str = IDS_LANGUAGE["0.1 floors"];
            break;
        }
        case 67: /*CSAFE_UNIT_STEPS*/
        {
            str = IDS_LANGUAGE["Steps"];
            break;
        }
        case 68: /*CSAFE_UNIT_REVOLUTIONS*/
        {
            str = IDS_LANGUAGE["revolutions"];
            break;
        }
        case 83: /*CSAFE_UNIT_STRIDES_PER_MINUTE*/
        {
            str = IDS_LANGUAGE["(strides/min)"];
            break
        }
        case 75: /* CSAFE_UNIT_HUNDREDTH_PERCENT_GRADE */
        case 76: /* CSAFE_UNIT_TENTH_PERCENT_GRADE */
        case 74: /* CSAFE_UNIT_PERCENT_GRADE */
        {
            str = IDS_LANGUAGE["(% grade)"];
            break;
        }
        default: {
            // nothing
            str = "";
            break;
        }
    }

    return str;
}

function convertFromDoubleToInt(dFrom, nUnit) {
    nValue = 0;
    var strFormat = "%d";

    switch (eval(nUnit)) {
    case 1: // CSAFE_UNIT_MILE
    case 33: // CSAFE_UNIT_KM
    {
        nValue = parseInt(dFrom);
        break;
    }
    case 2: // CSAFE_UNIT_TENTH_MILE
    case 8: // CSAFE_UNIT_TENTH_POUNDS
    case 17: // CSAFE_UNIT_TENTH_MPH
    case 34: // CSAFE_UNIT_TENTH_KM
    case 37: // CSAFE_UNIT_TENTH_METER
    case 40: // CSAFE_UNIT_TENTH_KG
    case 49: // CSAFE_UNIT_TENTH_KPH
    case 66: // CSAFE_UNIT_TENTH_FLOORS
    case 76: // CSAFE_UNIT_TENTH_PERCENT_GRADE
    case 79: // CSAFE_UNIT_TENTH_FLOORS_PER_MINUTE
    case 88: // CSAFE_UNIT_WATTS
    {
        nValue = eval(dFrom) * 10;
        break;
    }
    case 3: // CSAFE_UNIT_HUNDREDTH_MILE
    case 18: // CSAFE_UNIT_HUNDREDTH_MPH
    case 35: // CSAFE_UNIT_HUNDREDTH_KM
    case 50: // CSAFE_UNIT_HUNDREDTH_KPH
    case 75: // CSAFE_UNIT_HUNDREDTH_PERCENT_GRADE
    {
        nValue = eval(dFrom) * 100;
        break;
    }
    case 4: // CSAFE_UNIT_THOUSANDTH_MILE
    case 92: // CSAFE_UNIT_NEWTON_METERS
    case 98: // CSAFE_UNIT_THOUSANDTH_AMPERES
    case 100: // CSAFE_UNIT_THOUSANDTH_VOLTS
    {
        nValue = eval(dFrom) * 1000;
        break;
    }
    case 58: //CSAFE_UNIT_SECONDS_PER_MILE
    {
        // NOTE: we are returning early!
        //return sprintf("%d:%02d", eval(nValue/60), eval(nValue%60));
        break;
    }
    default: {
        nValue = parseInt(dFrom);
        break;
    }
    }

    return sprintf("%d", parseInt(nValue));

}

function convertToStringFromCSAFEUnit(nValue, nUnit)
{
    var dValue = 0.0;
    var strFormat = "%d";

    switch(parseInt(nUnit))
    {
        case 1: // CSAFE_UNIT_MILE
        case 33: // CSAFE_UNIT_KM
        {
            strFormat = "%d";
            dValue = parseInt(nValue);
            break;
        }
        case 2: // CSAFE_UNIT_TENTH_MILE
        case 8: // CSAFE_UNIT_TENTH_POUNDS
        case 17: // CSAFE_UNIT_TENTH_MPH
        case 34: // CSAFE_UNIT_TENTH_KM
        case 37: // CSAFE_UNIT_TENTH_METER
        case 40: // CSAFE_UNIT_TENTH_KG
        case 49: // CSAFE_UNIT_TENTH_KPH
        case 66: // CSAFE_UNIT_TENTH_FLOORS
        case 76: // CSAFE_UNIT_TENTH_PERCENT_GRADE
        case 79: // CSAFE_UNIT_TENTH_FLOORS_PER_MINUTE
        case 88: // CSAFE_UNIT_WATTS
        {
            strFormat = "%0.1f";
            dValue = parseInt(nValue) * 0.1;
            break;
        }
        case 3: // CSAFE_UNIT_HUNDREDTH_MILE
        case 18: // CSAFE_UNIT_HUNDREDTH_MPH
        case 35: // CSAFE_UNIT_HUNDREDTH_KM
        case 50: // CSAFE_UNIT_HUNDREDTH_KPH
        case 75: // CSAFE_UNIT_HUNDREDTH_PERCENT_GRADE
        {
            strFormat = "%0.2f";
            dValue = parseInt(nValue) * 0.01;
            break;
        }
        case 4: // CSAFE_UNIT_THOUSANDTH_MILE
        case 92: // CSAFE_UNIT_NEWTON_METERS
        case 98: // CSAFE_UNIT_THOUSANDTH_AMPERES
        case 100: // CSAFE_UNIT_THOUSANDTH_VOLTS
        {
            strFormat = "%0.3f";
            dValue = parseInt(nValue) * 0.001;
            break;
        }
        case 58: //CSAFE_UNIT_SECONDS_PER_MILE
        {
            // NOTE: we are returning early!
            return sprintf("%d:%02d", (nValue / 60), (nValue % 60));
            break;
        }
        default: {
            dValue = parseInt(nValue);
            break;
        }
    }

    return sprintf(strFormat, dValue);
}