/*=====================================================================
    Chimera Functions Script (CORE) | /js/hera.js
=====================================================================*/

Array.prototype.contains = function arrayContains(item) {
    for (var i = 0, ilen = this.length; i < ilen; i++) {
        if (this[i] === item) {
            return true;
        }
    }
    return false;
};

userIsLoggedIn = false;

/* Content: Featured -------------------------------- */
function featuredContent(context, type) {
	// Default to musicVideos if no type is given
	var type = type || "musicVideos";

	// Select content type.
	var media, featuredTitle, defaultFeaturedImage = "";
	switch (type) {
		case "onDemand":
			media = mediaXML.onDemand;
			var channel = Math.round(Math.random()*(media.length - 1));
			var show = Math.round(Math.random()*(media[channel].items.length - 1));

			var channelTitle = context.featured = media[channel];
			var showEpisode = context.featured = media[channel].items[show];

			var channels = channelTitle.title.split(",");
			var episodes = showEpisode.title.split(",");
			var featuredChannel = channels[Math.round( Math.random()*(channels.length - 1) )];
			featuredTitle = IDS_LANGUAGE.featuredContent["featuredOnDemand"] + ": " + channels;
			context.$featuredTitle.removeClass().addClass("featuredOnDemandTitle");
			featuredChannel = featuredChannel.toLowerCase().replace(/&amp;/g, "&").replace(/\s+/g, "").replace(/\//g, "_").replace(/:/g, "");	

			var featuredImages = new Array();
			var imageDir = DIR_ROOT+"/www/"+g_mfgStyle+"/images/featured/" + featuredChannel;
			var filelist = npfunctions.getFileList(imageDir, "*");
			$(filelist).find("file").each(function(index, element) {
				featuredImages.push($(element).text());
			});

			
			defaultFeaturedImage = imageDir + "/" + featuredImages[Math.round( Math.random()*(featuredImages.length - 1) )];
			break;
			
		case "musicVideos":
			media = mediaXML.musicVideos;
			var genre = Math.round(Math.random()*(media.length - 1));
			
			context.featured = media[genre];
			
			var genres = context.featured.title.split(",");
			var featuredGenre = genres[Math.round( Math.random()*(genres.length - 1) )];
			featuredTitle = IDS_LANGUAGE.featuredContent["featuredMusic"] + ": " + featuredGenre;
			context.$featuredTitle.removeClass().addClass("featuredMusicTitle");
			featuredGenre = featuredGenre.toLowerCase().replace(/&amp;/g, "&").replace(/\s+/g, "").replace(/\//g, "_");
			
			var featuredImages = new Array();
			var imageDir = DIR_ROOT+"/www/"+g_mfgStyle+"/images/featured/" + featuredGenre;
			var filelist = npfunctions.getFileList(imageDir, "*");
			$(filelist).find("file").each(function(index, element) {
				featuredImages.push($(element).text());
			});
			
			defaultFeaturedImage = imageDir + "/" + featuredImages[Math.round( Math.random()*(featuredImages.length - 1) )];
			break;
			
		case "lifescape":
			// If no va content was found default to LFconnect
			if (typeof vaObj.isAvailable != 'undefined' && vaObj.isAvailable()) {
				var media = eval(vaObj.getPlayListJson());
				var course = Math.round(Math.random()*(media.length - 1));
			
				context.featured = media[course];
				defaultFeaturedImage = DIR_ROOT+"/www/"+g_mfgStyle+"/images/featured/undefined.png";
				featuredTitle = IDS_LANGUAGE.featuredContent["featured"];
				context.$featuredTitle.removeClass().addClass("featuredTitle");
			}
			break;
			
		case "virtualTrainer":
			featuredTitle = IDS_LANGUAGE.featuredContent["featuredVt"];
			
			context.$featuredTitle.removeClass().addClass("featuredVtTitle");
			type = "virtualTrainer";
			context.featured = {};
			defaultFeaturedImage = DIR_ROOT+"/www/"+g_mfgStyle+"/images/featured/virtualTrainer.png";
			break;
			
		case "playlist":
		case "virtualActive":
			// Single level items
			var item = Math.round(Math.random() * (mediaXML[type].length - 1));
			if (item >= 0) {
				var mediaItem = mediaXML[type][item];
				context.featured = {
					'items': [mediaItem],
					'shuffle': false,
					'thumbnail': mediaItem.thumbnail,
					'title': mediaItem.title,
					'type': type
				};
			} else {
				i = (i - 1);
				break;
			}
			
			if (type == "playlist") {
				featuredTitle = IDS_LANGUAGE.featuredContent["featuredPlaylist"];
				
				context.$featuredTitle.removeClass().addClass("featuredPlaylistTitle");
				var genres = context.featured.genres;
				var featuredGenre = genres[Math.round( Math.random()*(genres.length - 1) )].toLowerCase();
				featuredGenre = featuredGenre.replace(/&amp;/g, "&").replace(/\s+/g, "").replace(/\//g, "_");
				
				var featuredImages = new Array();
				var filelist = npfunctions.getFileList(DIR_ROOT+"/www/"+g_mfgStyle+"/images/featured/" + featuredGenre, "*");
				$(filelist).find("file").each(function(index, element) {
					featuredImages.push($(element).text());
				});
			
				defaultFeaturedImage = featuredImages[Math.round( Math.random()*(featuredImages.length - 1) )];
			} else {
				featuredTitle = IDS_LANGUAGE.featuredContent["featuredVA"];
				context.$featuredTitle.removeClass().addClass("featuredVATitle");
				defaultFeaturedImage = DIR_ROOT+"/www/"+g_mfgStyle+"/images/featured/virtualactive/va.png";
			}
			break;
	}

	if (viewManager.currentView.name == "mainMenu") {
		featuredTitle = IDS_LANGUAGE.featuredContent["featuredMain"];
		context.$featuredTitle.removeClass().addClass("featuredMainTitle");
	}
	context.featured.type = type;
	var thumbnail = context.featured.thumbnail;
	var tnpart = null;
	if (typeof thumbnail == 'string') {
		tnpart = thumbnail.split('/'); // Split thumbnail image path.
		// Use last section of path.
		tnpart = tnpart[(tnpart.length - 1)];
		// Change to featured image path.
		tnpart = DIR_ROOT+"/www/"+g_mfgStyle+"/images/featured/" + ((featuredGenre) ? featuredGenre+"/" : "") + (tnpart.split('.'))[0] + ".png";
	}
	if (typeof tnpart == 'string' && file_exists(tnpart) == "1") {
		// If file is found, display it.
		context.$featuredImage.css({
			'background-image' : 'url(' + tnpart + ')'
		});
	} else if (file_exists(defaultFeaturedImage) == "1"){
		context.$featuredImage.css({
			'background-image' : 'url(' + defaultFeaturedImage + ')'
		});	
	} else {
		context.$featuredImage.css({
			'background-image' : 'url(images/featured/undefined.png)'
		});
	}
	context.$featuredTitle.html(featuredTitle);
}
/* END Content: Featured -------------------------------- */

/* SUB-SKIN CHECKS -------------------------------------- */
/*
    TODO:FIXME:XXX:CHANGEME: These functions should originate from C++
    Make sure that all width and height calculations for PCTV and 4Front have been replaced with this variable.
*/
function isWindowWidth(expectedWidth) {
  return( ( expectedWidth == (0 + $(window).width()) ) ? true : false );
}

// Check window size. Relates to PCTV.
var isPctv = (function isPctv() {
    return( isWindowWidth(1024) );
}());

// Check window size. Relates to 4Front.
var is4front = (function is4front() {
    return( isWindowWidth(1366) );
}());

/* END SUB-SKIN CHECKS ---------------------------------- */

function retrieveTvFavorites() {
	if (athleteObj.get_user_id() == "")
		return;
	
	var favorites = new Array();
	var urlParams = {
		"id" : athleteObj.get_user_id(),
		"location_id" : machineObj.getLocationId()
	};
	
	$.ajax({
		url: machineObj.getServerLocation() + "s2/getChannels",
		type: "GET",
		data: urlParams,
		success: function(data) {
			// Check error code of the response
			var apiResponse = $(data).find("api");
			var errorCode = parseInt(apiResponse.attr("error"));
			switch (errorCode) {
				case 0:
					writeLog("debug", "apiNoError: The call was executed successfully - no error resulted.");
					break;
				case 1:
					writeLog("debug", "apiGeneralError: An error occurred, but additional detail is not available.");
					break;
				case 5:
					writeLog("debug", "apiUnableToRetrieveExerciser: The system was unable to retrieve the specified exerciser from the database.");
					break;
				default:
					writeLog("debug", "An unrecognized error code was received from the previous api call");
					break;
			}			
			
			var channels = apiResponse.find("channels channel");
			channels.each(function() {
				favorites.push( $(this).text() );
			});
			
			if (errorCode == 0) {
				writeLog("info", "TV favorites were successfully retrieved from the server!");
				athleteObj.set_tv_favorites(favorites);
			} else 
				writeLog("info", "Uh-oh... TV favorites could not be retrieved");
		},
		error : function(jqXHR, textStatus, errorThrown) {
			writeLog("debug", "AJAX called failed! textStatus: " + textStatus + ", errorThrown: " + errorThrown);
			writeLog("info", "Uh-oh... TV favorites could not be retrieved");
		}
	});
}

function saveTvFavorites() { 
	// If the tv favorites haven't changed, don't bother saving
	if (!athleteObj.get_has_tv_favorites_changed())
		return;
		
	// Construct the xml string to send in the POST request to the server
	var favorites = athleteObj.get_tv_favorites();
	var xmlStr = '<channels npLogin="' + athleteObj.get_user_id() + '" locationId="' + machineObj.getLocationId() + '">';
	for (var i=0; i<favorites.length; i++) {
		xmlStr += '<channel>' + favorites[i] + '</channel>';
	}
	xmlStr += "</channels>";
	
	// Make the api call to the server so that we can save the user's tv favorites for the
	// club they're currently at.
	$.ajax({
		url: machineObj.getServerLocation() + "s2/setChannels",
		type: "POST",
		data: xmlStr,
		contentType: "text/xml; charset=utf-8",
		success: function(data) {
			// Check error code of the response
			var errorCode = parseInt($(data).find("api").attr("error"));
			switch (errorCode) {
				case 0:
					writeLog("debug", "apiNoError: The call was executed successfully - no error resulted.");
					break;
				case 1:
					writeLog("debug", "apiGeneralError: An error occurred, but additional detail is not available.");
					break;
				case 5:
					writeLog("debug", "apiUnableToRetrieveExerciser: The system was unable to retrieve the specified exerciser from the database.");
					break;
				default:
					writeLog("debug", "An unrecognized error code was received from the previous api call");
					break;
			}
			
			if (errorCode == 0) {
				writeLog("info", "TV favorites were successfully saved!");
				athleteObj.reset_has_tv_favorites_changed();
			} else 
				writeLog("info", "Uh-oh... TV favorites could not be saved");
		},
		error : function(jqXHR, textStatus, errorThrown) {
			writeLog("debug", "AJAX called failed! textStatus: " + textStatus + ", errorThrown: " + errorThrown);
			writeLog("info", "Uh-oh... TV favorites could not be saved");
		}
	});
}

function createResetUser() {
	window.user = {
    	id                     : null,
    	email                  : null,
    	password               : null,
    	gender                 : null,
    	dob                    : null,
    	firstName              : null,
    	lastName               : null,
   		secondaryID            : null,
    	secondaryDaysRemaining : null,
    	// New info added for LifeFitness
    	userIsLoggedIn		   : false,
    	hideProfilePic		   : false,
    	age					   : null,
    	weight				   : null,
    	connections				: {
    		facebook 		   :null,
    		twitter 		   :null,
    		fitnesspal	   :null
    							  },
    	//All the workoutHistoryData should be stored globally
    	workoutHistory		   : {
									total : null,
									workouts : []
    							 }

	};
	// CYA!!
	window.regUser = window.regFirst = window.user.firstName;
	window.userIsLoggedIn = window.user.userIsLoggedIn;
}
createResetUser();

DIR_ROOT = getNPRoot();

media_xml_exists = false;

doTransitions    = true;
SZ_DEFINE_MALE   = "1";
SZ_DEFINE_FEMALE = "0";
MEDIA_DIR        = "";
mediaXML         = null;
impressions      = new impressionsObj();
g_mfgStyle       = "";
availableApps    =
[
    { "name" : "attract",        "type" : "attractObj" },
    { "name" : "mainMenu",       "type" : "menuView" },
    { "name" : "playlist",       "type" : "musicPlaylistObj" },
    { "name" : "login",          "type" : "loginObj" },
    { "name" : "registration",   "type" : "registerObj" },
    { "name" : "workoutHistory", "type" : "workoutHistoryObj" },
    { "name" : "survey",         "type" : "surveyObj" },
    { "name" : "onDemand",       "type" : "ondemandObj" },
    { "name" : "music",          "type" : "musicObj" },
    { "name" : "personalNews",   "type" : "personalNewsViewObj" },
    { "name" : "endOfWorkout",   "type" : "endOfWorkoutObj" },
    { "name" : "install",		 "type" : "installObj" },
	{ "name" : "virtualActive",		 "type" : "virtualActiveObj" }
];

postmasterEnabled = false;

String.prototype.trim = function string_trim() { return this.replace(/^\s*/, "").replace(/\s*$/, ""); };

function runProgram(filename, args)
{
    if(0 == eval(npfunctions.file_exists(filename)))
        return false;

    var strCommand = filename;

    if(args != null)
        for (var i=0; i<args.length;i++) { strCommand += " " +  args[i]; }

    //  popError ('strCommand: ' + strCommand);
    var ret = npfunctions.run(strCommand);
    return ret;
}

//
//  Look for and parse the media.xml file. When we find it, set the MEDIA_ROOT to be the containing folder.
//


function randOrd(){ return (Math.round(Math.random())-0.5); }


function parseMediaXML()
{
    mediaXML = null;
    MEDIA_DIR = "";

    var dir = DIR_ROOT + "/data/prod/";
    var fileName=dir+"media.xml";
    writeLog("info", "Looking for media.xml in: " + dir);

    if(file_exists(fileName) == "1")
    {
        var fileStr = read_file(fileName);
        var xmlObject = (new DOMParser()).parseFromString(fileStr, 'text/xml');
        mediaXMLFound(dir, xmlObject);
		media_xml_exists = true;
    }

    if(MEDIA_DIR != "")
        return;

    // DON'T CHECK THE GW FOR NOW: Jeff
    return;

    writeLog("info", "Looking for media.xml - not found in "+dir+", checking gateway");

    //  TODO - Check if we have a gateway connection before doing this.
    dir = "http://"+systemObj.getGatewayIPAddress()+"/";

    $.ajax({
        url: dir + "media.xml",
        dataType: 'xml',
        async: false,
        timeout: 5000,
        success: function(data) { mediaXMLFound(dir, data); }
    });

    if(MEDIA_DIR != "")
        return;
    writeLog("error", "Media.xml not found in "+dir+" - media is disabled.");
}

function mediaXMLFound(dir, data)
{
    writeLog("info", "Media.xml FOUND in "+dir+", setting this as media directory.");
    MEDIA_DIR = dir;
    mediaXML = new mediaXMLObj($(data));
    writeLog("info", "Media.xml done");
}

//
//  Load JS scripts synchronously
//
function loadScript(src)
{
    if(!(file_exists(src) == "1")) {
        return;
    }

    $.ajax({
        url: src,
        dataType: 'script',
        async: false, 
        error: function(XMLHttpRequest, textStatus, errorThrown) { popError("Error loading "+src); }
    });
}

function loadJSON(src) {
    var json = {};
    
    try {
        var text = read_file(src);
        if (text.length == 0) {
            return json;
        }
        
        // Clean up the json string so that we can parse it.
        var commentBlock = /\/\*[^*]*\*\//g;
        var comment = /\/\/[^\n]*/g;
        text = text.replace(commentBlock, "").replace(comment, "");
        
        json = JSON.parse(text);
    } catch (e) {
        popError(e);
    }
    
    return json;
}

function SetFileContents(szFileName, szContents) { writeToFile(szFileName, szContents);}

//
//  Disable right click if the inspector is turned off in the machine.xml
//
function disableRightClick()
{
    try {
        if (machineObj.getInspector() == false) {
            $("body").bind("contextmenu", function(e) { return false; });
        }
    } catch(e) { popError(e); }
}

//
//  Initialize js on startup
//
function initialize()
{
    //  Get the skin name
    g_mfgStyle = machineObj.getSkinName();

    writeLog('info', 'My gateway IP: ' + systemObj.getGatewayIPAddress());
     
    parseMediaXML();

    //  Initialize globals
    adMan          = new adManager();
    viewManager    = new vwManager();
    
    if(typeof youTubePlayer != "undefined" && typeof enableYouTube != "undefined"){
    	youTubePlayer  = new youTubePlayer();
	}

	fbConnect = new facebookConnect();

	
    //masterTimer    = new masterTimerObj(); <-- not being used at the moment.
    activity       = new activityTracker();

    selectLanguage(machineObj.getLocale());

    //  Figure which apps are active based on available apps and activated apps in machine.xml
    prepareAppsList();
    getActivatedApps();

    //  Disable context menu if inspector is turned off.
    disableRightClick();

    reportHealth(); // start up health message timer
    
    postmaster = (postmasterEnabled) ? new postmasterGeneral() : false;

    $("#mainView").click(function mainViewClicked(e) { configPopup(e); });

    // Tells C++ we are up and running to turn back on the script 
    // taking too long dialog in case the application hangs.
    healthObj.set_loaded(true);
}

function checkForSyntaxErrors(src) {
    var sandbox = {};
    var errors = [];
    
    var data = read_file(src);
    if (data.length == 0) {
        return errors;
    }
    
    var i = window.frames.length;
    $(document.body).append("<iframe id='sandbox' style='display:none'></iframe>");
    sandbox = window.frames[i];
    
    // Set the string to evaluate in the sandbox environment. This is used to check for
    // syntax errors in the script
    sandbox.window.evalStr = data;
    
    sandbox.window.errors = [];
    sandbox.window.onError = function(error) {
        var errorMsg = error.toString();
        if (errorMsg.indexOf("SyntaxError") != -1) {
            sandbox.window.errors.push(errorMsg);
            sandbox.window.parent.writeLog("error", errorMsg + " on line " + error.line + " in " + src);
        }
    }
    
    // Create the script element to be appended to the sandbox iframe. The errorCheckScript will eval
    // the file contents inside a try-catch block to determine if there are any parse errors.
    var errorCheckScript = document.createElement("script");
    var js = "try { eval(window.evalStr); } catch(e) { window.onError(e); }";
    errorCheckScript.appendChild(document.createTextNode(js));
    
    // Append script element to the sandbox environment and record the syntax errors generated
    sandbox.document.body.appendChild(errorCheckScript);
    errors = sandbox.window.errors;
    
    $("iframe#sandbox").remove();
    
    return errors;
}

//
//  Update availableApps[] for this skin, figure which are active (via machine.xml), initialize the apps, then show the first app listed.
//
function prepareAppsList()
{
    var apps = loadJSON(DIR_ROOT+"/www/"+g_mfgStyle+"/jsi/apps.js");
    if (Array.isArray(apps)) {
        availableApps = apps;
    }
    
    var plugins = loadJSON(DIR_ROOT+"/plugins/"+g_mfgStyle+"/apps.js");
    if (Array.isArray(plugins)) {
        for (var i=0; i<plugins.length; i++) {
            var plugin = plugins[i];
            
            plugin.srcDir = DIR_ROOT+"/plugins/"+g_mfgStyle+"/views/";
            for (var j=0; j<availableApps; j++) {
                if (plugin.name.toLowerCase() == availableApps[j].name.toLowerCase()) {
                    plugins.splice(i--, 1);
                    break;
                }
            }
        }
        
        availableApps = availableApps.concat(plugins);
    }
    
    var appsList = getActivatedApps();
    if (appsList.length == 0) {
        popError("No available apps!");
        return;
    }
    
    initializeApps(appsList);
}


//
//  Get activated apps from machine.xml
//
function getActivatedApps()
{
    var src = DIR_ROOT + "/data/machine.xml";
    var activeApps = new Array();

    var fileStr = machineObj.getRawXML ();
    var xmlObject = (new DOMParser()).parseFromString(fileStr, 'text/xml');
    if (xmlObject != null) {
        activeApps = parseActivatedAppsList(xmlObject); 
    }
    else {
        popError("Error loading "+src);
    }

    return(activeApps);
}

//
//  Load apps based on list in machine.xml and available apps on client.
//
function parseActivatedAppsList(data)
{
    var apps = new Array();

    /* TODO: This code checks for <app> tags in machine.xml - should be enabled later.
    $(data).find("apps app").each(function() {

        if(!$(this).attr("name"))
            return;

        for(var i=0;i<availableApps.length;i++)
        {
            if(availableApps[i].name == $(this).attr("name"))
                apps.push(new app(availableApps[i].name, availableApps[i].type, viewManager, availableApps[i].superClass));
        }

    });
    */

    for(var i=0;i<availableApps.length;i++)
    {
        //if(availableApps[i].name == $(this).attr("name"))
            apps.push(new app(availableApps[i].name, availableApps[i].type, viewManager, availableApps[i].superClass, availableApps[i].srcDir));
    }

    return(apps);
}

//
//  Initialize all apps that will be available for this session.
//
function initializeApps(appsList)
{
    for(var i=0;i<appsList.length;i++)
        viewManager.initView(appsList[i]);

    viewManager.clearHistory();

    // Don't do anything if we are hidden. Wait for an OEM message.
    if (guiObj.visible) {
        viewManager.show(viewManager.views[0].name);
    }
}

//
//  Open the messenger modal to send messages up to C++
//
function openMessengerWindow()
{
    $("#messengerModal").fadeIn(150);
    $("#cMessage").val("").focus();
}

function hideMessengerModal()
{
    $("#messengerModal").fadeOut(150);
}

function sendCMessage()
{
    var msg = $("#cMessage").val();
    if(msg == "")
    {
        return;
    }

    nsSend1(msg);
}

function pageChange(page) {
    var args = arguments, msg = '';

    // Convert from unimplemented views to implemented ones.
    page = pageRedirect(page.toLowerCase());

    for (var i=1; i < args.length; i++) {
        msg += (i > 1) ? ", " + args[i] : args[i];
    }

    // Since this page change was initiated outside of our application, invalidate nextView.
    // Let the OEM decide what we should do next.
    if (viewManager.isViewAvailable(page)) {
        viewManager.nextView = null;
        viewManager.clearHistory();
    }

    switch(page) {
        case 'login': {
            viewManager.preLoadThenShow("login", true);
            break;
        }
        case 'mainmenu': {
            viewManager.preLoadThenShow("mainMenu", true);
            break;
        }
        case 'attract': {
            viewManager.show ("attract");
            break;
        }
        case 'summary': {
            viewManager.preLoadThenShow("endOfWorkout", true);
            setTimeout(function () { viewManager.activeObject.showCSafeEOW(args); }, 200);
            break;
        }
        case 'loginreg': {
            viewManager.preLoadThenShow("login", true);
            break;
        }
        default: {
            viewManager.preLoadThenShow(page, true, msg);
        }
    }
}

//
//  Config password popup
//
configPopupClicks = new Array();
popupClickablePaddingWidth = 200;
function configPopup(e)
{
    var $mainView = $("#mainView");


    //  Whenever the body is clicked, remove the password modal if it exists
    if($("#configPasswordModal").size() >= 1)
        $("#configPasswordModal").remove();

    var x = $mainView.width() - (e.pageX - $mainView.offset().left);
    var y = $mainView.height() - (e.pageY - $mainView.offset().top);

    var xLeft = false, xRight = false, yTop = false, yBottom = false;
    var clickCaught = false;

    if(e.pageX - $mainView.offset().left < popupClickablePaddingWidth)
        xLeft = true;

    if(e.pageY - $mainView.offset().top < popupClickablePaddingWidth)
        yTop = true;

    if(x < popupClickablePaddingWidth)
        xRight = true;

    if(y < popupClickablePaddingWidth)
        yBottom = true;

    switch(configPopupClicks.length)
    {
        case 0:
            if(xLeft && yTop)
                clickCaught = true;
            break;
        case 1:
            if(xRight && yTop)
                clickCaught = true;
            break;
        case 2:
            if(xRight && yTop)
                clickCaught = true;
            break;
        case 3:
            if(xLeft && yTop)
                clickCaught = true;
            break;
        default:
            break;
    }

    if(clickCaught)
    {
        if(configPopupClicks.length >= 3)
        {
            configPopupClicks = null;
            configPopupClicks = new Array();
            showConfigPopup();
        }
        else
            configPopupClicks.push(1);
    }
    else
        configPopupClicks = new Array();
}

function showConfigPopup()
{	  

    if($("#configPasswordModal").size() >= 1)
        $("#configPasswordModal").remove();

    var htmlStr = "<div id='configPasswordModal'><input id='configPasswordInput' /><ul>" +
        "<li><span>1</span></li>" +
        "<li><span>2</span>abc</li>" +
        "<li><span>3</span>def</li>" +
        "<li><span>4</span>ghi</li>" +
        "<li><span>5</span>jkl</li>" +
        "<li><span>6</span>mno</li>" +
        "<li><span>7</span>pqrs</li>" +
        "<li><span>8</span>tuv</li>" +
        "<li><span>9</span>wxyz</li>" +
        "<li class='clear'><span>Clear</span></li>" +
        "<li><span>0</span></li>" +
        "<li class='enter'><span>Enter</span></li>" +
        "</ul></div>";
    $("body").append(htmlStr);

    var $configModal = $("#configPasswordModal");
    $("#configPasswordModal ul").bind("mousedown", function(e) { enterCode(e); });
}

function enterCode(e)
{
    var $target = $(e.target);
    if(!($target.is("li")) && !($target.parent().is("li")))
        return false;

    if($target.parent().is("li"))
        $target = $target.parent();

    var $inputBox = $("#configPasswordInput");

    if($target.is(".enter"))
    {
        parseSecretCode($inputBox.val());
        $inputBox.val("");
    }
    else if($target.is(".clear"))
        $inputBox.val("");
    else
        $inputBox.val($inputBox.val() + $target.find("span").html());
}

function showPopUp(url, options) {
    var $modalPopupDiv = $("#modalPopupDiv"),
        windowWidth = window.outerWidth,
        windowHeight = window.outerHeight,
        modalWidth = ((options == "stick") ? 800 : ((options == "demo") ? 300 : 500)),
        modalHeight = ((options == "demo") ? 300 : 600);

    if ($modalPopupDiv.exists()) {
        $modalPopupDiv.remove();
    }

    modalWidth = ((modalWidth <= windowWidth) ? modalWidth : windowWidth);
    modalHeight = ((modalHeight <= windowHeight) ? modalHeight : windowHeight);

    var modalLeft = ((windowWidth - modalWidth) / 2),
        modalTop = ((windowHeight - modalHeight) / 2);

    $modalPopupDiv = $("<div id='modalPopupDiv' class='modalPopupDiv'><!--/ Modal Pop-Up /--></div>")
        .css({
            "width" : modalWidth + "px",
            "height" : modalHeight + "px",
            "left" : modalLeft + "px",
            "top" : modalTop
            })
        .load(url, function () {
            $("#modalPopupDiv").find(".TB_closeWindowButton").bind("mousedown", function () {
                $("#modalPopupDiv").remove();
            });
        });

    $("body").append($modalPopupDiv);
}

function showIframe(url)
{
	var iframe_src = " src='" + url + "' ";
	var frame ="<div id='bandwidth_container'>"+
		"<div id='bandwidth_wrap'>"+
			"<iframe id='bandwidth_meter' " + iframe_src  +"></iframe>"+
		"</div>"+
		"<div id='bandwidth_meter_close'>"+
			"<div class='sp_closeAjaxWindow'>"+
				"<button id='refreshIframe' class='sp_closeWindowButton install' onclick='refreshIframe();'><span></span></button>"+
				"<button id='closeIframe' class='sp_closeWindowButton install cancel' onclick='closeIframe();'><span></span></button>"+
			"</div>"+
		"</div>"+
	"</div>";
	
	$('body').append(frame);
	$('body').find('#refreshIframe span').html(IDS_LANGUAGE.secretCode.iframe['refreshIframe']);
	$('body').find('#closeIframe span').html(IDS_LANGUAGE.secretCode.iframe['closeIframe']);

}

function refreshIframe()
{
    var bandwidth_meter = document.getElementById( 'bandwidth_meter' );
    var url = bandwidth_meter.src;
    bandwidth_meter.src = "";
    bandwidth_meter.src = url;
}

function closeIframe()
{
    var iframe = document.getElementById('bandwidth_meter');
    iframe.parentNode.removeChild(iframe);
    $('#bandwidth_meter').empty().remove();
    $('#bandwidth_meter_close').empty().remove();
    $('#bandwidth_container').empty().remove();
}

function parseSecretCode(code)
{
    // Check to see if the code is in the <skin>/control.xml file
    // If not, return early...

    if (!controlObj.codeExists(code)) {
        writeLog('info', 'code does not exist for this skin: '+ code);
        $("#configPasswordModal").remove();
        return ;
    }
    writeLog('info', 'code does exist for this skin: ' + code);

    switch(code)
    {
        case "3366":
            showDemoModeToggle();
            break;
        case "78425":
            var stickInstallPage = DIR_ROOT + "/www/stickinstall.html";
            showPopUp(stickInstallPage , "stick"); // pass for stick width height
            $("#configPasswordModal").remove();
            break;
        case "77333":
            showIframe("http://www.tracert.org/bandwidth_meter/");
            $('.TB_closeWindowButton').trigger("click");
            $("#configPasswordModal").remove();
            break;
        case "911":
             $('.TB_closeWindowButton').trigger("click");
             var configLocation = DIR_ROOT + "/www/config.html";
	         showPopUp(configLocation, "demo"); //pass for stic width height
             $("#configPasswordModal").remove();              
             break;
        case "5455":
             npfunctions.runAsync("/usr/bin/pkill gui","");         
             break;
        case "27233": {
             // CSAFE
             var configLocation = DIR_ROOT + "/www/csafetest.html";
             window.location = configLocation;
             break;
        }
        case "3696": /* DOWN */
        	ShowConfigPowerDown();
            break;
        case "2582": /* Club install */
            var success = writeToFile(DIR_ROOT+"/data/install", '{ "pages" : [ "network__interface_type","tv_config" ] }');
            if(success)
                ShowConfigPowerDown();
            else
                popError("There was an error while writing the install file.");
            break;
        case "4763": /* iPod */
            if (!identifyObj.isMatrix4x3()) {
                this.writeToFile(DIR_ROOT+'/data/install', '{ "pages" : ["ipod"] }');
                window.location='/netpulse/www/install.html';
            }
            break;
        case "7226": /* Scan (TV) */
			$('.TB_closeWindowButton').trigger("click");
			if ( this.writeToFile(DIR_ROOT + '/data/install', '{ "pages" : ["tv_config"] }') ) {
				if (viewManager.activeObject)
                    viewManager.activeObject.hide();
				this.window.location.assign(DIR_ROOT + '/www/install.html');
			} else {
				popError(IDS_LANGUAGE.secretCode['popErrorInstall']);
			}
            $("#configPasswordModal").remove();
			break;
		case "4638": /* INET */ {
			$('.TB_closeWindowButton').trigger("click");
			if ( this.writeToFile(DIR_ROOT + '/data/install', '{ "pages" : ["network__interface_type"] }') ) {
				if (viewManager.activeObject) viewManager.activeObject.hide();
                    this.window.location.assign(DIR_ROOT + '/www/install.html');
			} else {
				popError(IDS_LANGUAGE.secretCode['popErrorInstall']);
			}
            $("#configPasswordModal").remove();
            break;
        }
		case "5264": /* LANG */ {
			$('.TB_closeWindowButton').trigger("click");
			if ( this.writeToFile(DIR_ROOT + '/data/install', '{ "pages" : ["configure_language"] }') ) {
				if (viewManager.activeObject)
                    viewManager.activeObject.hide();
				this.window.location.assign(DIR_ROOT + '/www/install.html');
			} else {
				popError(IDS_LANGUAGE.secretCode['popErrorInstall']);
			}
            $("#configPasswordModal").remove();
            break;
        }
        case "543372273": {
             // lifescape
             var configLocation = DIR_ROOT + "/www/lifefitness/va_validate.html";
             window.location = configLocation;
             break;
        }        
        case "86824": {
            /* TOUCH screen calibration */
            touchScreenCalibration();
            $("#configPasswordModal").remove();
            break;
        }
        case "21967": {
             // LF-COMM
             var tmp = DIR_ROOT + "/www/lifefitness/lf-comm.html";
             window.location = tmp;
             break;
        }
        case "7247": {
            /*pair*/
            if ( this.writeToFile(DIR_ROOT + '/data/install', '{ "pages" : ["assign_computer_name"] }') ) {
                if (viewManager.activeObject)
                    viewManager.activeObject.hide();
                this.window.location.assign(DIR_ROOT + '/www/install.html');
            } else {
                popError(IDS_LANGUAGE.secretCode['popErrorInstall']);
            }
            $("#configPasswordModal").remove();
            break;
        }
        default: {
            $("#configPasswordModal").remove();
            break;
        }
    }
}

function showDemoModeToggle()
{
    var $modal = $("#configPasswordModal");
    $modal.html("<h2 id ='demoTitle'></h2><button id='demoModeOn'></button><button id='demoModeOff'></button>");
    $modal.find("#demoModeOn").bind("click", function() { demoModeOnClicked(); });
    $modal.find("#demoModeOff").bind("click", function() { demoModeOffClicked(); });
    
    //modal strings
    $modal.find("#demoTitle").html(IDS_LANGUAGE.secretCode.demo["demoTitle"]);
    $modal.find("#demoModeOn").html(IDS_LANGUAGE.secretCode.demo["demoModeOn"]);
    $modal.find("#demoModeOff").html(IDS_LANGUAGE.secretCode.demo["demoModeOff"]);

    if(machineObj.getMachineDemoNetwork())
        $("#demoModeOn").addClass("chosen");
    else
        $("#demoModeOff").addClass("chosen");
}

function demoModeOnClicked()
{
    $("#demoModeOn").addClass("chosen");
    $("#demoModeOff").removeClass("chosen");

    machineObj.setDemoNetwork('true');
	setTimeout(function () {  
	$("#configPasswordModal").hide(); 
		if (viewManager.activeObject.name == 'attract' && typeof(viewManager.activeObject.showSupportInfo) == "function")
			viewManager.activeObject.showSupportInfo(machineObj.getMachineDemoNetwork());
	},3000);
}

function demoModeOffClicked()
{
    $("#demoModeOn").removeClass("chosen");
    $("#demoModeOff").addClass("chosen");

    machineObj.setDemoNetwork('false');
	setTimeout(function () { 
	$("#configPasswordModal").hide();
		if (viewManager.activeObject.name == 'attract' && typeof(viewManager.activeObject.showSupportInfo) == "function")
			viewManager.activeObject.showSupportInfo(machineObj.getMachineDemoNetwork());
	},3000);
}
function ShowConfigPowerDown()
{	
	var $modal = $("#configPasswordModal");
	$modal.addClass("shutDown");
    $modal.html(' <div id="ShutDownDiv">'
    		+ '<h2 id="shutTitle"></h2>'
    			+'<div id="Wrapper_wrapper">'
    				
    					+'<button id="PowerDownButton"><span style="font-size:15px; text-align: center;"></span></button>'
    					+'<button id="closeButton"><span style="font-size:15px;"></span></button>'

    			+'</div>'
    		+ '</div>');
    //modal strings
    $modal.find("#shutTitle").html(IDS_LANGUAGE.secretCode.shutDown["shutTitle"]);
    $modal.find("#PowerDownButton span").html(IDS_LANGUAGE.secretCode.shutDown['PowerDownButton']);
    $modal.find("#closeButton span").html(IDS_LANGUAGE.secretCode.shutDown['closeButton']);
    
    $modal.find("#PowerDownButton").bind("click", function() { shutDown(); });
    $modal.find("#closeButton").bind("click", function() { $("#configPasswordModal").hide(); });


}
function shutDown()
{
    npfunctions.run("/usr/bin/sudo /netpulse/bin/n5i-sys shutdown");
}
//
//  Handle end of vlc video
//
function onMediaPlayerEndReached()
{
    try {

    if(viewManager.activeObject.nextVideo)
        viewManager.activeObject.nextVideo();

    if($("#popUpAd").exists())
    	$('#popUpAd').remove();

    } catch(e) { popError(e); };
}

//
//  Handle vlc error
//
function onMediaPlayerEncounteredError()
{
    try {

    if(viewManager.activeObject.mediaError)
        viewManager.activeObject.mediaError();

    } catch(e) { popError(e); }
}

function onTvConfigUpdated() {
    // tvConfig.js is not included in install.html, so we need to check for the existence
    // of this object before we operate on it.
    // TODO: Refactor the installer to use the tvConfig object
    if (typeof tvConfig !== "undefined") {
        // Clear the channel list to force an update when accessed again
        tvConfig.clearChannelList();
    }
}

function pageRedirect(page) { return(page); /* SEE: https://npjira.atlassian.net/browse/QT-550 */ }

//  BEGIN DO NOT TOUCH - C++ CALLS
// We really need to let the OEM do the setTimeout 0 since some calls C++
// callers might need to block on the item finishing.
function appShow(page) { doAppShow(page); }
function appHide(page) { 

    // if we want to pause the video instead of stopping when hidden
    // then skip this step
    if (!controlObj.hasPauseHide()) {
        if (viewManager.activeObject.stopVideo) {
            viewManager.activeObject.stopVideo();
        }
        else {
            stopVideo($("#videoContainer"));
        }
    }
    doAppHide(page);    
}
function appStartOfWorkout() { doAppStartOfWorkout(); }
//  END DO NOT TOUCH - C++ CALLS

function doAppHide(page)
{
    // do nothing by default. Let the skin override this
}

function doAppStartOfWorkout()
{
    // do nothing by default. Let the skin override this
}


function appEndOfWorkout() { baseEndOfWorkout(); }

// User and View cleanup tasks.
function baseEndOfWorkout() {
// TODO:FIXME:XXX: Move user/view cleanup tasks into system-level routines.

	// Save the user's custom music video playlist and tv favorites if their list has changed.
	var chosenVideos = this.listChanged;

	if(chosenVideos == true){
		userCustomPlaylist.save();
		this.listChanged = false;
	}else{
		this.listChanged = false;
	}

	saveTvFavorites();
	


    // Reset the shared memory for workout data and athlete.
    npfunctions.resetWorkoutData();

    // Reset the window.user objects and properties.
    createResetUser();
    userCustomPlaylist.reset();

    // Clear all TV/Enabled Channels, if the tvConfig exists.
    if (tvConfig && "function" == typeof tvConfig.clearChannelList) { tvConfig.clearChannelList(); }

	// Save impressions for last user.
	impressions.writeImpressions();

	// Create new ad/video impressions object for new user.
	impressions = new impressionsObj();

	// Reset Ad Data
	adMan.resetAdData();

    // Reset the default language.
	selectLanguage(machineObj.getLocale());

    viewManager.clearHistory();

    if((machineObj.isOutsideUS() && mediaXML.onDemand.length > 0) || (!machineObj.isOutsideUS() && mediaXML.onDemand.length == 0)){
    	mediaXML.loadOnDemandContent();
    }

	// Run final cleanup hook.
    doAppEndOfWorkout();

	writeLog("info", "=== Terminate Gui ===");
	// WRAP IT UP!!!
}

function doAppEndOfWorkout() { } 

function isUserInSession()
{
    var bRet = false;

    bRet = (workoutdataObj.get_csafe_application_state() == "CSAFE_EMBEDDED")
        ?   workoutdataObj.get_is_user_in_session()
        :   (parseInt(workoutdataObj.get_time_seconds()) > 0);

    return bRet;
}


function showModal(msg,autoClose)
{
    var $modal = $("#errorModal");
    var $modalMsg = $("#errorMsg");
    var $modalContent = $("#errorModalContent");

    $modal.css("visibility","hidden").css("display","block");
    $modalMsg.html(msg);
    var totalHeight = $modalContent.height() + parseInt($modalContent.css("padding-top")) + parseInt($modalContent.css("padding-bottom"));

    var top = (($modal.height() - totalHeight)/2) - 50;

    $modalContent.css("top", top+"px");
    $modal.css("display","none").css("visibility","visible").fadeIn(300);

    if(autoClose){
    	var duration = (autoClose && (autoClose >= 0 || autoClose < 0) && autoClose !== true) ? autoClose : 2000;
    	setTimeout(function() { $('#errorModal').fadeOut(300); },duration);
    }
    else
	    $('#modalOkButton').css('display','block');
}

function hideModal()
{
    $('#errorModal').fadeOut(300);
}

//
//  Global stop video player functionality
//
function stopVideo($videoContainer)
{
    if (typeof(guiObj) != 'undefined') {
        if ($videoContainer.find('#videoPlayer').hasClass('CBSContent')) {
            guiObj.showCBSOverlay(false);
        } else {
            guiObj.showFullscreenButton(false);
        }
    }

    if($("#videoProgress").length)
    	$("#videoProgress").hide();
    
    $videoContainer.css("visibility","hidden");
    $("#videoPlayer").css("visibility","hidden").remove();	
}

//
//  Global start video player functionality
//
startPlayerTimeout = null;
function playVideo($videoContainer, playerString) {
    // We should either call stopVideo here, or set the contents of $videoContainer to be playerString,
    // rather than appending. Multiple calls to playVideo will create multiple video players on the screen.
    $videoContainer.append(playerString);

    if (typeof(guiObj) != 'undefined') {
        var coords = {
            w : function coordW() { return (0 + $videoContainer.width()); },
            h : function coordH() { return (0 + $videoContainer.height()); },
            x : function coordX() { return (0 + window.screenX + $videoContainer.offset().left); },
            y : function coordY() { return (0 + window.screenY + $videoContainer.offset().top); }
        };
        // Add overlay if we play CBS content
        if ($videoContainer.find('#videoPlayer').hasClass('CBSContent')) {
            // For TRUE we must add 180x165 pixels to the video container offset.
            guiObj.showCBSOverlay(true, coords.x(), coords.y(), coords.w(), coords.h());
        } else {
            guiObj.showFullscreenButton(true, coords.x(), coords.y(), coords.w(), coords.h());
        }
    }

    $videoContainer.show();

    if (startPlayerTimeout) {
        clearTimeout(startPlayerTimeout);
    }

    startPlayerTimeout = setTimeout(function() {
        $videoContainer.css("visibility", "visible");
        showProgressbar();
    }, 200);
}

function media_dir_cleanup(media_dir) {
    return(media_dir.replace(/\bfile:\/\//, ''));
}

hTimer = null;

function reportHealth()
{
    clearTimeout(hTimer);

    // no healh message for uninstalled machines
    if (!configObj.isInstalled()) {
        hTimer = setTimeout(function() { reportHealth(); }, 10*60*1000);
        writeLog('info', ' This machine is uninstalled: no report');
        return;
    }

    try {
        var url;
        url = machineObj.getServerLocation() + 'n5ireport.jsp?';
        url += 'mid='        + configObj.getMid();
        url += '&client='    + getVersion();
        url += '&skin_name=' + machineObj.getSkinName();
        url += '&guid='      + getMediaGUID();
        url += '&lan_ip='    + systemObj.getIPAddress();
        url += '&mac='       + systemObj.getMACAddress();

        var diskUsage = getSkinDiskUsage();

        var partitionsUsage = null;
        if (diskUsage) {
            partitionsUsage = diskUsage.split("/");
            url += '&disk_root_pct=' + (Math.ceil(partitionsUsage[0]));
        }
        // hit the gateway if the string is the same.
        if (healthObj.is_report_equal(url)) {
            url = 'http://' + systemObj.getGatewayIPAddress() + ':80/cgi/notify.py?mid=' + configObj.getMid();
			dirtyHarry(
                url,                                
                function (data) { /*notifyResponse we need a response on the notify side or else */ }
            );
        }
        else {
            var self = this;
            dirtyHarry(url, function(data){ 
                var response = data.getElementsByTagName('response')[0].getAttribute("code");
                // report strings were different and we got a ACK.  Write it out
                writeLog('info', 'n5ireport.jsp response: ' + response);
                if (response == 0) {
                    healthObj.write_report(url);
                }
            });
        }
    } catch(e) { popError(e); }

    hTimer = setTimeout(function() { reportHealth(); }, 10*60*1000);
}

function selectLanguage(locale) {
	$('body').attr('locale', locale);
	$('#mainView').attr('locale', locale);
	$('#install_body').attr('locale', locale);

    var language = locale.split ('_');
    var localeCore = "/www/locale/";

    if (identifyObj.isLifeFitnessAddOn()) {
        localeCore = "/www/" + machineObj.getSkinName() + "/localeCore/";
    }

    var mainLanguage = DIR_ROOT + localeCore + language[0] + '.js';
    if ("1" == file_exists(mainLanguage)) {
        loadScript(mainLanguage);
    }

    var skinScript = DIR_ROOT + "/www/" + machineObj.getSkinName() + "/locale/" + language[0] + ".js";
    if ("1" == file_exists(skinScript)) {
        loadScript(skinScript);
    }

    if (file_exists(skinScript) == 1 || file_exists(mainLanguage) == 1) {
    // having them without the == seems to return always true whether its a 0 or 1 returned
        setTimeout(function selectLanguageHtmlStrings() {
            try {
                if (typeof viewManager != 'undefined' && viewManager.activeObject) {
                    var activeObj = viewManager.activeObject;
                    athleteObj.set_locale(locale);

                    // Make sure all HTML/DOM elements are found.
                    runLanguageFunction(activeObj, 'bindHTMLElements');

                    // Make sure all skin-specific HTML/DOM elements are found.
                    runLanguageFunction(activeObj, 'bindSkinSpecificElements');

                    // Set IDS_LANGUAGE text.
                    runLanguageFunction(activeObj, 'htmlInternationalString');
                }
            } catch(e) { popError(e); }
        }, 500 );
    }
}

// Helper function to reduce duplicate code in 'selectLanguage' function.
function runLanguageFunction(activeObj, functionToRun) {
    try {
        var languageFunction = null;
        if (activeObj[functionToRun]) {
            languageFunction = activeObj[functionToRun];
        } else if (activeObj.vm && activeObj.vm[functionToRun]) {
            languageFunction = activeObj.vm[functionToRun];
        }
        if (typeof(languageFunction) == 'function') {
            languageFunction.call(activeObj);
        }
    } catch(e) {
        popError(e);
    }
}

function getMediaGUID()
{
    try {

    var filename = media_dir_cleanup(MEDIA_DIR) + "media.xml";
    var fileStr = read_file(filename);
    var xmlObject = (new DOMParser()).parseFromString(fileStr, 'text/xml');

    var guid = xmlObject.getElementsByTagName("media")[0].getAttribute("id");

    if(guid == "") guid = "0";

    return(guid);

    } catch(e) {return("0");}
}

function evalJSON(strJSON)
{
  return eval('(' + strJSON + ')');
}

/*
* keyPressEvent(...) This function will be called when a key on the keyboard
*   is pressed down
* Params:
*   key: represent an unsigned long of the key pressed (i.e. F12 == 16777275)
*   isAutoRepeat: 0: no, 1: yes
*
*/
// Qt values
KEY_F1 = 16777264;
KEY_F2 = 16777265;
KEY_F3 = 16777266;
KEY_F4 = 16777267;
KEY_F5 = 16777268;
KEY_F6 = 16777269;
KEY_F7 = 16777270;
KEY_F8 = 16777271;
KEY_F9 = 16777272;
KEY_F10 = 16777273;
KEY_F11 = 16777274;
KEY_F12 = 16777275;
function keyPressEvent(key, isAutoRepeat) {
//  writeLog("info", "keyPressEvent("+key+", "+isAutoRepeat+")");

  if (typeof coustomKey == 'undefined' || coustomKey == undefined || coustomKey == null) {
      return;
  }

  // handle the Netpusle Volume/Channels hardware
  switch(key) {
    case KEY_F1: {
      // F1: Main Menu
      setTimeout(function () { coustomKey.mainMenu(); } , 0);
      break;
    }
    case KEY_F2: {
      // F2: Select
      
      break;
    }
    case KEY_F3: {
      // F3: Right (next)
	   setTimeout(function () { coustomKey.left(); } , 0);
      break;
    }
    case KEY_F4: {
      // F4: Volume Down
	  setTimeout(function () { coustomKey.volumeDown(); } , 0);
      break;
    }
    case KEY_F5: {
      // F5: Left (back)
	  setTimeout(function () { coustomKey.left(); } , 0);
      break;
    }
    case KEY_F6: {
      // F6: Volume Up
	   setTimeout(function () { coustomKey.volumeUp(); } , 0);
      break;
    }
    default: {
      // do nothing!
    }
  }
}

/*
* keyReleaseEvent(...) This function will be called when a key on the keyboard
*   that WAS pressed down is released (up).
* Params:
*   key: represent an unsigned long of the key pressed (i.e. F12 == 16777275)
*   isAutoRepeat: 0: no, 1: yes
*
*/
function keyReleaseEvent(key, isAutoRepeat) {
  writeLog("debug", "keyReleaseEvent("+key+", "+isAutoRepeat+")");
}

function endWorkout(){
	workout.endWorkout();
	
}

//
//Check for streaming-enabled media xml
//
function isStreamingEnabled()
{
var filename = media_dir_cleanup(MEDIA_DIR) + "media.xml";
var fileStr = read_file(filename);
var xmlObject = (new DOMParser()).parseFromString(fileStr, 'text/xml');

return(xmlObject.getElementsByTagName('list').length > 0)
}


function touchScreenCalibration()
{
    // Fantaay calibration program
    if ("1" == file_exists("/usr/local/bin/LinearAp")) {
        // figure out what device the touchscreen is
        var hid_device = "/dev/usb/hiddev0";
        for (var i = 0 ; i < 5; i++)
        {
            if ("1" == file_exists("/dev/usb/hiddev"+i))
            {
                hid_device = "/dev/usb/hiddev"+i;
                break;
            }
        }

        npfunctions.run("/usr/local/bin/LinearAp "+hid_device+" 9");
    }
    // DCI calibration program
    else if ("1" == file_exists("/usr/bin/hlincal")) {
        npfunctions.run("/usr/bin/hlincal -q 9");
    }
    // Penmount calibration
    else if ("1" == file_exists("/usr/sbin/gCal")) {
        npfunctions.run("/usr/bin/sudo /usr/sbin/gCal 9"); 
    }
    else {
        popError('Touch screen calibration not available.');
    }
}

/*
 *  Decode the specified UTF-8 encoded string.
 *  If the decoding fails, it's probably because the string
 *  wasn't UTF-8.  In that case, it just returns the original
 *  string.
 */
function decodeUTF8(str) {

    try {
        return decodeURIComponent(escape(str));
    }
    catch (e) {
        return str;
    }
}

function convertSecToReadableTime(timeInt){
	//TODO: Move it upscale so that the same function can be used 
	//for all the skins
	
	//O/P: HH:MM:SS
	var tsecs = parseInt(timeInt);
	var hours = Math.floor(tsecs / (60 * 60));
	tsecs -= (60 * 60 * hours);
	var mins = Math.floor(tsecs / 60);
	var secs = Math.ceil(tsecs - (mins * 60));

	// Convert null values
	if (isNaN(hours))
		hours = 0;
	if (isNaN(mins))
		mins = 0;
	if (isNaN(secs))
		secs = 0;

	// convert from int in secs to time string
	var timeStr = "";

	if (hours > 0) {
		timeStr += String(hours);
		timeStr += ":";
	} else
		timeStr += "00:";

	if (mins < 10)
		timeStr += "0";

	timeStr += String(mins);
	timeStr += ":";

	var secStr = String(secs);
	if (secStr.length == 1)
		timeStr += "0";

	timeStr += secStr;

	return timeStr;
}

function showProgressbar(){
	
	var videoLength = guiObj.getVideoLength();//videoLength in seconds
	var videoPlayedPer = guiObj.getVideoTimeElapsedInPer();
	
	if(isPctv || !$("#videoProgress").length || $("#videoContainer").css("visibility") != "visible" || videoLength <= 0)
	{
		return;
	}
	
	$("#videoProgress").css("display","inline-block");
	var videoTobePlayed = Math.round(((100 - videoPlayedPer)/100)*videoLength);//Returns length of video played in seconds
	
	var readableTime = convertSecToReadableTime(videoTobePlayed).replace("00:","");
	
	var progressbarWrapperWidth = parseInt($("#progressbarWrapper").css("width"));
	var progressbarLeftWidth = Math.round((progressbarWrapperWidth)*(videoPlayedPer/100))-1;
	progressbarLeftWidth = (progressbarLeftWidth <= 0)? 0 : progressbarLeftWidth;
	var progressbarRightWidth = progressbarWrapperWidth - progressbarLeftWidth - 2;
	
	if(progressbarRightWidth <= 0){
		progressbarRightWidth = 0;
		progressbarLeftWidth = progressbarWrapperWidth - 2;
	}
	
	$("#progressbarWrapper #progressbarLeft").css("width",progressbarLeftWidth + "px");
	$("#progressbarWrapper #progressbarRight").css("width",progressbarRightWidth + "px");
	$("#videoProgress #timeLeft").html(IDS_LANGUAGE["advertisement"] + ": " + readableTime);
}