//
//  pauseResumeUI - used to draw "UNABLE TO COMMUNICATE", "PLEASE RESUME", "ARE YOU THERE", and "MACHINE INACTIVE" modals
//
function pauseResumeUI()
{
    //  JQuery references to the HTML elements we reference regularly
    this.$modal = $("#id_pause_resume");
    this.$stillHereButton = $("#id_still_here_btn");
    this.$pauseButton = $("#id_pause_btn");
    this.$quitButton = $("#id_quit_btn");
    this.$modalText = $("#id_modalText");
    this.$timeoutText = $("#id_timeout");
    this.$modalOverlay = $("#simplemodal-overlay");

    this.start_count_down = false;
    
    //this.startCountDownInt = 5;
    this.startCountDownInt = 1;
    
    this.start_count_down_interval = this.startCountDownInt;

    this.are_you_there_started = false;
    this.are_you_there_int = 1;

    this.areYouThereTimer = null;

    this.INACTIVITY_CHECK_SCREENS =
    [
        "selectWorkout",
        "login",
        "register"
    ];

    this.init();
    
}

//  --------------------------------------------------------
//      Set inital text/click functionality to paused state and attach noteActivity() to body events
//  --------------------------------------------------------
pauseResumeUI.prototype.init = function()
{
    var _this = this;
    //  Set the text for pauseResume popup
    this.$modalText.html(IDS_LANGUAGE["PleaseResume"]);
    this.$stillHereButton.html(IDS_LANGUAGE["Yes"]);
    this.$pauseButton.html(IDS_LANGUAGE["Resume"]);
    this.$quitButton.html(IDS_LANGUAGE["EndWorkout"]);

    this.noTrackingShown = false;
    this.showNoTrackingTimeout = null;

    
    //  Count all up/down/move as activity
    
    this.$modal.hide();
    this.$modalOverlay.hide();
    $("body").bind("mousedown", function() { _this.noteActivity();});
    
    $("#id_still_here_btn").bind("click", function () {_this.stillHereClick();_this.noteActivity();});
    //$("#id_pause_btn").bind("click", function () {_this.resumeClick();});//<== TODO
    //$("#id_quit_btn").bind("click", function () {_this.endWorkoutClick();});//<== TODO
}

//----------------------------------------------------------
//          Init calls this function each second, needs to be implemented using master timer in future sprint.
//-----------------------------------------------------------
pauseResumeUI.prototype.intervalTicker = function()
{
    if(this.are_you_there_started)
    {
        if(this.are_you_there_int > 0)
        	this.are_you_there_int--;

        if(this.are_you_there_int == 0)
        {
            this.are_you_there_int = -1;
            this.areYouThere();
        }
    }
	
	if(this.start_count_down)
	{	
		if(this.start_count_down_interval > 0)
			this.start_count_down_interval--;

		if(this.start_count_down_interval == 0)
		{
			this.countingDown();
			this.start_count_down_interval = this.startCountDownInt;
		}
	}
}

pauseResumeUI.prototype.reset = function() {
    writeLog('info', 'pauseResumeUI.reset()');
    if (null != this.showNoTrackingTimeout) {
        window.clearTimeout(this.showNoTrackingTimeout);
        this.showNoTrackingTimeout = null;
    }

    this.noTrackingShown = false;
}

//  ------------------------------------------------------
//      Draw appropriate modal.
//  ------------------------------------------------------
pauseResumeUI.prototype.show = function(type)
{
	
	switch(type)
    {
        case "ARE_YOU_THERE":
        {
            this.show_AreYouThere();
            break;
        }
        case "STATUS_BYTE_OFFLINE":
        case "STATUS_BYTE_MANUAL":
        {
            this.show_StatusByteManual();
            break;
        }
        default:
            return;
    }

	//  Shrink any/all flash players to make sure the popup shows properly (bug #1867)
    this.hideFlashObjects();
    this.hideVLCObjects();

    //  Show the modal div
    this.$modal.show().css({'display':'inline-block'});
    this.$modalOverlay.show();
}

//----------------------------------------------------
//Hide VLC player
//-------------------------------------------------
pauseResumeUI.prototype.hideVLCObjects = function()
{
    if (viewManager.currentView.name == 'watch') {
        setVLCFullscreen("false");
        this.$vlcObject = $('object#videoPlayer').parent().addClass("minimize");
        return; // return early (Skin Support: Netpulse & Lifefitness)
    }
    
    var foo = null;

    if(viewManager.currentView.name == "tv")
        foo ="videoPlayerObject";

    else if(viewManager.currentView.name == "onDemand" || viewManager.currentView.name == "music")
        foo = "id_onDemandVideoPlayerObject";

    else if(viewManager.currentView.name == "eas")
        foo = "customContentPlayer";

    if(foo)
        killVideoPlayer(foo);
}

pauseResumeUI.prototype.showVLCObjects = function()
{
    
    if (viewManager.currentView.name == 'watch') {
        this.$vlcObject = $('object#videoPlayer').parent().removeClass("minimize");
        return; // return early (Skin Support: Netpulse & Lifefitness)
    }
    
    var foo = null;

    if(viewManager.currentView.name == "tv")
        foo = document.getElementById("videoPlayerObject");

    else if(viewManager.currentView.name == "onDemand" || viewManager.currentView.name == "music")
        foo = document.getElementById("id_onDemandVideoPlayerObject");

    else if(viewManager.currentView.name == "eas")
        foo = document.getElementById("customContentPlayer");

    if(foo)
    {
        foo.style.visibility = "visible";
        foo.style.display = "block";
    }
}


pauseResumeUI.prototype.hideFlashObjects = function()
{   
    if (viewManager.currentView.name == 'watch') {
        if (typeof(guiObj) != 'undefined') {
            var $videoContainer = $("#videoContainer");
            if ($videoContainer.find('#videoPlayer').hasClass('CBSContent')) {
                guiObj.showCBSOverlay(false);
            }
        } 
        return; // return early (Skin Support: Netpulse & Lifefitness)
    }
    
    $("#id_cbsVideoPlayerObject").css("width", "1px").css("height", "1px");
    $("#id_youtubeVideoPlayerObject").css("width", "1px").css("height", "1px");
}

pauseResumeUI.prototype.showFlashObjects = function()
{   
    if (viewManager.currentView.name == 'watch') {
        // Add overlay if we play CBS content
        if (typeof(guiObj) != 'undefined') {
            var $videoContainer = $("#videoContainer");
            if ($videoContainer.find('#videoPlayer').hasClass('CBSContent')) {
                guiObj.showCBSOverlay(true, $videoContainer.offset().left, $videoContainer.offset().top, $videoContainer.width(), $videoContainer.height());
            }
        }
        return; // return early (Skin Support: Netpulse & Lifefitness)
    }
    
    $("#id_cbsVideoPlayerObject").css("width", "100%").css("height", "100%");
    $("#id_youtubeVideoPlayerObject").css("width", "100%").css("height", "100%");
}

//  ---------------------------------------------------
//      Draw AreYouThere modal and begin endWorkout countdown
//  ---------------------------------------------------
pauseResumeUI.prototype.show_AreYouThere = function()
{
	this.setAreYouThereText();

    this.$stillHereButton.show();
    this.$pauseButton.hide();
    this.$quitButton.hide();
    this.$timeoutText.show();
    this.startCountdown();

    //  Write "Are You There modal - displayed." to log
    writeLog('info', 'Are You There modal - displayed.');
}
//---------------------------------------------------
//      Draw show_StatusByteManual modal and begin endWorkout countdown
//---------------------------------------------------
pauseResumeUI.prototype.show_StatusByteManual = function()
{
    var modalText = IDS_LANGUAGE["ToProperlyTrackThisWorkout"];

    if (window.userIsLoggedIn) {
        modalText = (window.regFirst == "null") ? IDS_LANGUAGE["User"] + window.regUser : window.regFirst;
        modalText += " " + IDS_LANGUAGE["ToProperlyTrackThisWorkout"];
    }

    this.$modalText.html("<small>" + modalText + "</small>");

    this.$stillHereButton.hide();

    // change the text
    this.$pauseButton.html(IDS_LANGUAGE["Cancel"]);
    this.$pauseButton.show();
    this.$quitButton.show();
    this.$timeoutText.hide();

    this.start_count_down = false;
    var _this = this;

    this.$pauseButton.bind("mousedown", function() {
        _this.hide();
    });

    this.$quitButton.html(IDS_LANGUAGE["EndWorkout"]).bind("mousedown", function() {
        _this.hide();
        viewManager.show("endOfWorkout");
    });

    //  Write to log
    writeLog('info', 'Manual modal - displayed.');
}
//  ---------------------------------------------------
//      Begin endWorkout countdown
//  ---------------------------------------------------
pauseResumeUI.prototype.startCountdown = function()
{
    //  Reset timeout - default to 3 minutes if no value available.
    this.nTimeOut = (parseInt(parent.workoutdataObj.get_please_resume_timeout()) == 0) ? 15 : parent.workoutdataObj.get_please_resume_timeout();

    //  Set timeout text to full timeout
    var msg = sprintf("%s %d:%s %s.", IDS_LANGUAGE["ThisSessionWillEndIn"], parseInt(this.nTimeOut/60), sprintf("%02d", parseInt(this.nTimeOut%60)), IDS_LANGUAGE["seconds"]);

    this.$timeoutText.html(msg);

    this.start_count_down = true;
}

pauseResumeUI.prototype.countingDown = function()
{
    this.nTimeOut--;

    var msg = sprintf("%s %d:%s %s.", IDS_LANGUAGE["ThisSessionWillEndIn"],
        parseInt(this.nTimeOut/60), sprintf("%02d", parseInt(this.nTimeOut%60)), IDS_LANGUAGE["seconds"]);

    this.$timeoutText.html(msg);

    //  If we have counted to zero, terminate and return early.
    if(parseInt(this.nTimeOut) <= 0)
    {
        //  Write "Are You There modal - displayed." to log
        writeLog('info', 'Are You There modal - No response from user, terminating.');
        this.$modal.hide();
        this.$modalOverlay.hide();
        this.terminate();
        return;
    }
}

//  ---------------------------------------------------
//      Hide pauseResume modal and kill timers
//  ---------------------------------------------------
pauseResumeUI.prototype.hide = function()
{
    this.showFlashObjects();
    this.showVLCObjects();

    this.$modal.hide();
    this.$modalOverlay.hide();

    this.start_count_down  = false;
}

//  -----------------------------------------------------------
//      Set the pause_resume modal text to "Are you there..."
//  -----------------------------------------------------------
pauseResumeUI.prototype.setAreYouThereText = function()
{
    var modalText =  IDS_LANGUAGE["AreYouThere"];

    //  If user is logged in and has entered their name online, use their first name.
    //  Otherwise if they are logged in, use their user id number.
    //  If not logged in, use generic message.
    modalText += 
        (user.userIsLoggedIn)
            ? (!user.firstName || user.firstName == "null")
                ? " user "+user.id
                : " "+user.firstName
            : "";
    modalText += "?";

    this.$modalText.html(modalText);
}

//  --------------------------------------------------------------
//      When the user clicks the "Resume" button in the "Please resume" modal (embedded devices),
//      disable the "Resume" button for three seconds and call pauseWorkout() toggle function.
//  --------------------------------------------------------------

pauseResumeUI.prototype.pauseWorkout = function()
{
     pauseWorkout();
}
pauseResumeUI.prototype.resumeClick = function()
{
    var _this = this;

    this.$pauseButton
        .attr("disabled",true)
        .css("opacity",0.5);


   setTimeout(function() {

        _this.$pauseButton
            .attr("disabled",false)
            .css("opacity",1);

    } , 1000*3);

    this.showFlashObjects();
    pauseWorkout();
}

//  ----------------------------------------------------------
//      When the user clicks the "End Workout" button in the "Please resume" modal (embedded devices),
//      disable the "End Workout" button for three seconds and call stopWorkout() toggle function.
//  ----------------------------------------------------------
pauseResumeUI.prototype.endWorkoutClick = function()
{
    this.$quitButton
        .attr("disabled",true)
        .css("opacity",0.5);

   setTimeout(
        function()
        {
        //  Using direct reference to the button because of anonymous function scope
        $("#id_quit_btn")
            .attr("disabled",false)
            .css("opacity",1);

        }
    , 1000*3);

    this.terminate();
}

//  ---------------------------------------------------------------
//      When the user clicks the "Yes" button in the "Are you there" modal (non-embedded devices),
//      disable the "Yes" button for three seconds and hide the modal (timer will be reset 
//      automatically by the body.onClick event).
//  ---------------------------------------------------------------
pauseResumeUI.prototype.stillHereClick = function()
{
    var _this = this;
	this.$stillHereButton
        .attr("disabled",true)
        .css("opacity",0.5);

    setTimeout(
        function()
        {
        //  Using direct reference to the button because of anonymous function scope
        $("#id_still_here_btn")
            .attr("disabled",false)
            .css("opacity",1);
        }
    , 1000*3);
	
    //  Write "Are You There modal - User is still here." to log
    writeLog('info', 'Are You There modal - User is still here.');
    clearInterval(_this.areyouthereInterval);
    this.start_count_down = false;
    this.showFlashObjects();
    this.showVLCObjects();
    hideModal();
    this.$modal.hide();
    this.$modalOverlay.hide();
}


//  -------------------------------------
//      End workout
//  -------------------------------------
pauseResumeUI.prototype.terminate = function()
{
    var _this = this;
	this.hide();
    endWorkout();
	if(this.$modalOverlay)
		this.$modalOverlay.hide();
}

//
//  Note that the user has done something, so we can reset the inactivity timer.
//  This is triggered by body.onclick().
//
pauseResumeUI.prototype.noteActivity = function()
{
	if(viewManager.currentView.name != "attract")
		this.restartInactivityTimers();
}

//
//  Cancel the currently scheduled inactivity timer.
//
pauseResumeUI.prototype.cancelInactivityTimer = function()
{
    clearTimeout(this.inactivityTimer);
}

//
//  Start the inactivity timer.
//  This will return the app to the attract screen if the user doesn't
//  do anything for the next INACTIVITY_TIMEOUT_SECS seconds.
//
pauseResumeUI.prototype.restartInactivityTimers = function()
{
    try {

        var _this = this;

        //  If on a non-embedded device, start a new timer to display "Are you there?" modal
        if(workoutdataObj.get_csafe_application_state() != "CSAFE_EMBEDDED")
        {
            if (workoutdataObj.get_csafe_enabled() == 1)
            {
                //  Self-powered machine
                if (workoutdataObj.get_status_byte() == "STATUS_BYTE_ERROR")
                {
                    this.are_you_there_started = true;
                    this.are_you_there_int = 1 * machineObj.getAreYouThere();
                }

                //  Otherwise, we have an active communication with the csafe slave.
            }
            else
            {
                this.are_you_there_started = true;
                this.are_you_there_int = 1 * machineObj.getAreYouThere();
            }

        }
        //  If CSAFE_EMBEDDED and belt is disengaged (dynamic mode), check every five seconds to see if 
        //  the current speed is zero. If so, start the are you there timer.
        else if(workoutdataObj.get_belt_state() == 1)
        {	
        	if(this.dynamicModePausedInterval)
            {
                clearInterval(this.dynamicModePausedInterval);
                this.dynamicModePausedInterval = null;
            }

            if(!this.dynamicModePausedInterval){
            	this.dynamicModePausedInterval = setInterval(
                        function()
                        {
                            if(workoutdataObj.get_speed() != 0)
                            {
                                clearTimeout(this.areYouThereTimer);
                                this.areYouThereTimer = null;
                                this.areYouThereTimer = setTimeout(_this.areYouThere, 1000 * 120);
                            }
                        },
                    5000);
            }
        }
    	
    	if(this.areyouthereInterval){
    		clearInterval(this.areyouthereInterval);
        	this.areyouthereInterval = null;
    	}
    	
    	if(!this.areyouthereInterval){
    		this.areyouthereInterval = setInterval(function () {_this.intervalTicker();showProgressbar();}, 1000);
    	}

        } catch(e) {popError(e);}
}

//
//  The areYouThere timer has been reached. Display the "Are you there?" modal with a countdown
//  that restarts the workout if the user is not looking at the attract view or any views in INACTIVITY_CHECK_SCREENS.
//
pauseResumeUI.prototype.areYouThere = function()
{
	var me = this;
	if(!viewManager.currentView)
        return;

    if($.inArray(viewManager.currentView.name, this.INACTIVITY_CHECK_SCREENS) > -1)
    {
        if(!isUserInSession())
            viewManager.show("attract");
    }
    else if(viewManager.currentView.name != "attract" && viewManager.currentView.name != "endOfWorkout"){
    	me.show("ARE_YOU_THERE");
    }
}
