
function truePlaylistObj(name, type, vm, superClass)
{
    this.name = name;
    this.type = type;
    this.vm = vm;
    this.superClass = superClass;
    listChanged = false;
    // this.core = new (eval(superClass))(name, type, vm);
    
    this.pagesToDisplay = ["page0"];
}

//  Inherit core prototype for this app
truePlaylistObj.prototype = new musicPlaylistObj;

truePlaylistObj.prototype.show = function truePlaylistObjShow()
{
    try {
        this.loadContent();

        $paginationDiv.hide();

        this.setupMenuData();
    
    this.slidingBox = new slidingBox(
        this.menuData,
        $("#viewPort"),
        $("#playlistContainer"),
        $("#backButton"),
        $("#nextButton"),
        1,
        200
    );


    var _this = this;

    this.keyboard = null;
    this.chosenVideos = new Array();
    if(userCustomPlaylist.items.length)
        for(var i=0;i<userCustomPlaylist.items.length;i++)
            this.chosenVideos.push(userCustomPlaylist.items[i].id);


    //  Main Video Container Setup
    this.$mainVideoContainer = $("#mainVideoContainer");
    this.$mainVideoHeader = this.$mainVideoContainer.find("h1");
    this.$mainVideoList = this.$mainVideoContainer.find("#mainVideoList");



    this.mainSlidingBox = new multiSlidingBox(
        this.$mainVideoList,
        this.$mainVideoList.parent().find(".scrollUp"),
        this.$mainVideoList.parent().find(".scrollDown"),
        this.$mainVideoList.parent().find(".scrollBack"),
        "mainVideoList",
        4
    );

    //  My Video Container Setup
    this.$myVideoContainer = $("#myVideoContainer");
    this.$myListHeader = this.$myVideoContainer.find("h1");
    this.$myVideoList = this.$myVideoContainer.find("#myVideoList");

    this.mySlidingBox = new multiSlidingBox(
        this.$myVideoList,
        this.$myVideoList.parent().find(".scrollUp"),
        this.$myVideoList.parent().find(".scrollDown"),
        this.$myVideoList.parent().find(".scrollBack"),
        "myVideoList",
        1,
        4
    );

    this.$titleField     = $("#customTitle");
    this.$playlistInputTitle = $("#playlistTitle");
    this.$watchNowButton = $("#watchNowButton");
    this.$shuffleButton  = $("#shuffleToggleButton");
    this.$saveButton     = $("#saveButton");
    //Keyboard Init
    
    this.$titleKeyboard  = $("#id_email_keyboard");
    this.$editButton = $("#editButton");
    this.$enterButton = $("#enterButton");
	
    this.updateTitleField(userCustomPlaylist.title);

    this.attachEvents();
    this.updateMainList(0);
    this.initMyList();
    
    if(userCustomPlaylist.shuffle == true)
   		this.$shuffleButton.addClass("shuffleYes");
         
    this.mainSlidingBox.$levels[0].find("button").bind("mousedown."+this.name, function(e) { _this.mouseDownPos = e.pageY; })
        .bind("mouseup."+this.name, function(e) { _this.introListClicked(e);    _this.slidingBox.$back.hide();})
        ;

    // As per https://npjira.altassian.net/browse/QT-536
    // Just go to the Custom Playlist
    this.$modalPopUp = $("#modalPopUp");
    var modalStr = (athleteObj.get_user_id()=="")
            ?   "LogInRequired"
            :   (this.chosenVideos.length > 0)
                ?   "New/Edit"
                :   "";

    if (modalStr.length > 0)
        this.showModal(modalStr);

    } catch(e) {return false; }

    this.htmlInternationalString();

    return true;
};

truePlaylistObj.prototype.showModal = function truePlaylistObjShowModal(modalStr, callback) {
	this.$modalPopUp.css("visibility", "hidden");
	musicPlaylistObj.prototype.showModal.call(this, modalStr, callback);
	
	var $contents = this.$modalPopUp.find("#contents");
	var height = $contents.outerHeight();
	$contents.css("margin-top", "-" + Math.round(height/2) + "px");
	
	this.$modalPopUp.css("visibility", "visible");
};


truePlaylistObj.prototype.unHideMyPlaylist = function truePlaylistObjUnHideMyPlaylist() {
	
    //  Shrink the main container
//    if(doTransitions)
//        this.$mainVideoContainer.removeClass("expanded").animate({width : "100%"}, 500);
//    else
//        this.$mainVideoContainer.removeClass("expanded").css("width","100%");
    this.$mainVideoContainer.removeClass("expanded");

    //  Adjust the left coordinate of the main container
    var position = this.mainSlidingBox.getCurrentlyScrolling().css("left");
    this.mainSlidingBox.$container.css("left", (-1*parseInt(position))+"px");
    this.$mainVideoContainer.find("h1").css("text-align", "left");
    //add float left to playlist
    if(!this.$myVideoContainer.hasClass("unhidePlaylist"))
      this.$myVideoContainer.addClass("unhidePlaylist");
    
    // Remove the "Remove" text from the custom playlist menu.
    this.$myVideoContainer.find('a.subtract').each(function() {
    	$(this).html = '';
    });
};

truePlaylistObj.prototype.attachEvents = function truePlaylistObjAttachEvents() {
    var me = this;
    musicPlaylistObj.prototype.attachEvents.call(this);
    this.$saveButton.unbind("click.*").bind("click."+this.name, function() { 
    	me.savePlaylist(); 
    }); 

};

truePlaylistObj.prototype.htmlInternationalString = function truePlaylistObjHtmlInternationalString() { 
	musicPlaylistObj.prototype.htmlInternationalString.call(this);
	$('#backString').html("");
    $('#nextString').html("");
    $('.menu_button h2').html(IDS_LANGUAGE["customMusicVideoPlaylist"]);
};

truePlaylistObj.prototype.watchNow = function truePlaylistObjWatchNow() {
	if (this.chosenVideos.length == 0) {
		showModal(IDS_LANGUAGE["addVideo"], true);
		return;
	}

	this.savePlaylist();
	this.removeEvents();

	// Wait two seconds while playlist saves, then show music page and play playlist.
	setTimeout(function() {
		// Accessing userCustomPlaylist.items will return a clone, which can safely be modified without affecting the original list.
		// Note that changes to userCustomPlaylist will not affect the clone.
		var channel = {
			"items": userCustomPlaylist.items,
			"title": userCustomPlaylist.title,
			"shuffle": userCustomPlaylist.shuffle,
			"type": "playlist"
		};
		watchObj.target = {
			"parentView" : viewManager.currentView,
			"channel" : channel, // List of media items to play
			"episode" : 0 // Start with first video
		};
		viewManager.show("watch");
	}, 2000);

};

