/*---------------------------------------------------------------------
    TV View Object (True) | true/views/tv/js.js
---------------------------------------------------------------------*/

function trueTvObj(name, type, vm)
{
    this.name = name;
    this.type = type;
    this.vm = vm;

	this.enabledChannels.itemsPerPage = 10;
	this.favorites.itemsPerPage = 5;
}

//  Inherit from the core tvObj
trueTvObj.prototype = new tvObj;

// Overridden to change the login prompt for guest user
trueTvObj.prototype.buildSlideBox = function() {
	var me = this;
	me.favorites.slideBox = new slidingBox(
		me.favorites.data,
		me.$favoritesSlidingViewPort,
		me.$favoritesVidBrowser,
		me.$favoritesBackButton,
		me.$favoritesNextButton,
		1,
		200,
		null,
		me.$favoritesCueContainer,
		true
	);
	
	if (me.$favoritesVidBrowser.html() == "") {
		if (athleteObj.get_user_id() > "") {
			this.$favoritesVidBrowser.html('<li><p></p></li>');
		} else {
			this.$favoritesVidBrowser.html('<div id="login"><button></button><div></div></div>');
			this.$favoritesVidBrowser.find("#login > button").bind("mousedown." + me.name, function() {
				me.vm.nextView = "tv";
				me.vm.show("login");
			});
		}
	}
	// Adjust the Channel favorites to fit channel name
	me.favorites.slideBox.$box.find(".menu_button").not(".icon").each(me.fitTextToButton);			

	// Adjust all future calls to redraw the Channel favorites as well
	me.favorites.slideBox.baseDrawList = me.favorites.slideBox.drawList;
	me.favorites.slideBox.drawList = function() {
		me.favorites.slideBox.baseDrawList();
		me.favorites.slideBox.$box.find(".menu_button").not(".icon").each(me.fitTextToButton);	
	};

	me.enabledChannels.slideBox = new slidingBox(
		me.enabledChannels.data,
		me.$channelsSlidingViewPort,
		me.$channelsVidBrowser,
		me.$channelsBackButton,
		me.$channelsNextButton,
		1,
		200,
		null,
		me.$channelsCueContainer,
		true
	);
	// Adjust the Channel Line-up to fit the channel name
	me.enabledChannels.slideBox.$box.find(".menu_button").not(".icon").each(me.fitTextToButton);
};

trueTvObj.prototype.watch = function(slideBox) {
	var selectedChannel = this.enabledChannels.slideBox.chosenItems[0];
	if (slideBox == this.favorites.slideBox) {
		// Channel was selected from favorites list; get the index of the 
		// selected channel from the enabled channels list.
		for (var i=0; i<this.enabledChannels.slideBox.data.items.length; i++) {
			if (this.favorites.slideBox.data.items[this.favorites.slideBox.chosenItems[0]].channel == this.enabledChannels.slideBox.data.items[i].channel) {
				selectedChannel = i;
				break;
			}
		}
	}
	
	var channelInfo = this.enabledChannels.slideBox.data.items[selectedChannel];
	nsSend4("op=button","id="+channelInfo.id,"channel="+channelInfo.channel,"extra="+channelInfo.extra);
}

trueTvObj.prototype.postShowHook = function trueTvObjPostShowHook() {
    this.useBackToMenuButton(this.enabledChannels.slideBox);
    
    // If we couldn't determine the originView, default to mainMenu. The parent/origin view should
    // always be Entertainment Menu for True, anyways
    if (!this.originView) this.originView = "mainMenu";
};

/*-------------------------------------------------------------------*/
//@ sourceURL=true/views/tv/js.js

