/*-------------------------------------------------------------------
	Workout History Script (True) | views/true/workoutHistory/js.js
---------------------------------------------------------------------*/

workoutHistoryObj.prototype.preShowHook = function trueWorkoutHistoryObjPreShowHook() {
    this.maxRows = 7;
};


workoutHistoryObj.prototype.bindHTMLElements = function()
{
	var me = this;

    me.$mainContainer = $('div#workoutHistoryView');
    me.$woDataContainer = me.$mainContainer.find('#dataContainer');
    me.$userTab = me.$mainContainer.find('#user_info_tab');
    me.$woHistoryTab = me.$mainContainer.find('#wo_history_tab');
};

workoutHistoryObj.prototype.attachEvents = function()
{
	var me = this;
	me.$userTab.bind("mousedown."+this.name, function(){
		viewManager.show('info');
	});
};


workoutHistoryObj.prototype.fetchRecords = function(beg, end) {
	
	var me = this, locName = machineObj.getLocationName(), workout, workoutDate;

	if (machineObj.getMachineDemoNetwork()) {
		$.getJSON(
			DIR_ROOT + '/www/demo/n5ihistory.json',

		function(data) {
			if (!data || data.workouts.length == 0) {
				me.showNoWorkoutsPrompt();
				return;
			}

			me.totalWorkouts = data.total;

			for ( var i = 0; i < data.workouts.length; i++) {
				me.workouts.push(data.workouts[i]);
			}

			me.drawTable();
		});
	} else {
		$.getJSON(
			machineObj.getServerLocation() + "n5ihistory.jsp", {
			user_id : athleteObj.get_user_id(),
			machine_id : configObj.getMid(),
			beg : String(beg),
			end : String(end)
		},

		function(data) {
			try {

				if (!data || data.workouts.length == 0) {
					me.showNoWorkoutsPrompt();
					return;
				}

				me.totalWorkouts = data.total;

				for ( var i = 0; i < data.workouts.length; i++) {
					me.workouts.push(data.workouts[i]);
				}
				//Draw Workout History Table
				me.drawTable();

				//Pull user info from server and display
				if (0 < data.workouts.length) {
					workout = data.workouts[0];

					if (workout.date_time) {
						var workoutDateSplit = ((workout.date_time.split(" "))[0].split("-"));
						workoutDate = workoutDateSplit[1] + "/" + workoutDateSplit[2] + "/" + workoutDateSplit[0];
					} else {
						workoutDate = "";
					}
					me.lastWorkoutDate = workoutDate;

					me.lastWorkoutDistance = (workout.distance && workout.distance_units) ? workout.distance + " " + workout.distance_units : "0 " + IDS_LANGUAGE.miles;
					me.lastWorkoutCalories = (workout.calories) ? workout.calories : "0";
					me.lastWorkoutDuration = (workout.duration) ? convertSecToReadableTime(workout.duration) : "00:00:00";
					me.lastWorkoutActivity = (workout.type) ? workout.type : "";

	}

			} catch (e) {
				popError(e);
			}
		});
	}
};

