/*=====================================================================
	User Accounts Script (CORE) | views/accounts/js.js
=====================================================================*/

// Constructor for the User Accounts Object.
function accountsObj(name, type, vm) {
	var me = this;
	user.connections.facebook = 0;
	user.connections.twitter =0;
	user.connections.fitnesspal = 0;

	// App properties.
	me.name = name;
	me.type = type;
	me.vm = vm;

	// HTML/DOM elements.
	me.$container = null;
	me.$container = null;
	me.$infoHeader = null;
	me.$title = null;
	me.$infoContent = null;

	return me;
}

// Inherit all of the page life-cycle methods.
accountsObj.prototype = new app;

// Show the User Accounts View.
accountsObj.prototype.show = function coreAccountsObjShow() {
	var me = this;
	try {
		// Add functions to the beginning of the view.
		me.preShowHook();
		// Find DOM elements.
		me.bindHTMLElements();
		// Bind listeners to DOM elements.
		me.attachEvents();
		// Internationalize text.
		me.htmlInternationalString();
		// Get user data.
		me.getData();
		// Display user data.
		me.displayData();
		// Add functions to the end of the view.
		me.postShowHook();
	} catch (e) {
		popError(e);
		return false;
	}

	return true;
};

// Add functions to the beginning of the view.
accountsObj.prototype.preShowHook = function coreAccountsObjPreShowHook() {

	var me = this;
	//show facebook toggle states from OEM message
	if(user.connections.facebook == 0){
		$('#facebookToggle').addClass('toggleOn');
		$('#facebookToggle').removeClass('toggleOff')
	}else if(user.connections.facebook == 1){
		$('#facebookToggle').removeClass('toggleOn')
		$('#facebookToggle').addClass('toggleOff');
	}
	//show twitter toggle states from OEM message
	if(user.connections.twitter == 0){
		$('#twitterToggle').addClass('toggleOn');
		$('#twitterToggle').removeClass('toggleOff')
	}else if(user.connections.twitter == 1){
		$('#twitterToggle').removeClass('toggleOn')
		$('#twitterToggle').addClass('toggleOff');
	}

	//show my fitness pal toggle states from OEM message
	if(user.connections.fitnesspal == 0){
		$('#myFitnessPalToggle').addClass('toggleOn');
		$('#myFitnessPalToggle').removeClass('toggleOff')
	}else if(user.connections.fitnesspal == 1){
		$('#myFitnessPalToggle').removeClass('toggleOn')
		$('#myFitnessPalToggle').addClass('toggleOff');
	}
	return me;
};

// Find DOM elements.
accountsObj.prototype.bindHTMLElements = function coreAccountsObjBindHTMLElements() {
	var me = this;

	me.$container = $('div#accountsView');
	me.$infoHeader = me.$container.find('header#infoHeader');
	me.$title = me.$infoHeader.find('h1.title');
	me.$infoContent = me.$container.find('#infoContent');
	me.$accountsContentBody = me.$container.find("#accountsContentBody");
	me.$facebookToggleButton = me.$container.find("#facebookToggle");
	me.$twitterToggleButton = me.$container.find("#twitterToggle");
	me.$myFitnessPalToggleButton = me.$container.find('#myFitnessPalToggle');

	return me;
};

accountsObj.prototype.setArgs = function(args){
	var me = this;
    var pairs = args.split (',');
    for (var i = 0; i < pairs.length; i++) {
        var nv = pairs[i].split('=');
        if (nv[0] == undefined || nv[1] == undefined) {
            continue;
        }
        if (nv[0] == 'facebook_toggle') {
            if(nv[1] == 'on') {
                user.connections.facebook=1;
            }  
        }
        else if (nv[0] == 'twitter_toggle') {
            if(nv[1] == 'on') {
                user.connections.twitter=1;
            } 
        }
        else if (nv[0] == 'fitnesspal_toggle') {
            if(nv[1] == 'on') {
                user.connections.fitnesspal=1;
            } 
        }
        
    }
}


// Bind listeners to DOM elements.
accountsObj.prototype.attachEvents = function coreAccountsObjAttachEvents() {
	var me = this;

	$('#paginationDiv').hide();
	//Get Facebook & Twitter Callback from the OEM
    //msgObj.regAfterMsg("op=view", "accountsObj.prototype.toggleFacebook()");

    //Facebook Toggle Button
	me.$accountsContentBody.find("#facebookToggle").bind("mousedown." + me.name, function(e) {

	  if(me.$facebookToggleButton.attr('class') == "toggleOff"){ 
	  //animate toggle button position
      $(this).animate({'background-position': "117px -1px" }, 'fast');
      //remove previous class
      $(this).removeClass('toggleOff');
      //assign new class
      $(this).addClass('toggleOn');
      //send message to EOM
	  nsSend3("op=button","id=facebook_toggle", "state=off");
      }

      else if(me.$facebookToggleButton.attr('class') == "toggleOn"){ 
      //animate toggle button position
      $(this).animate({'background-position': "186px -1px" }, 'fast');
      //remove previous class
      $(this).removeClass('toggleOn');
      //assign new class
      $(this).addClass('toggleOff');
      //send message to OEM
      nsSend3("op=button","id=facebook_toggle","state=on");
  		}

  

	});

	//Twitter Toggle Button
	me.$accountsContentBody.find("#twitterToggle").bind("mousedown." + me.name, function(e) {
       if(me.$twitterToggleButton.attr('class') == "toggleOff"){ 
       	//animate toggle button position
      	$(this).animate({'background-position': "117px -1px" }, 'fast');
      	//remove previous class
      	$(this).removeClass('toggleOff');
      	//assign new class
      	$(this).addClass('toggleOn');
      	//send message to OEM
      	nsSend3("op=button","id=twitter_toggle", "state=off");
      }

      else if(me.$twitterToggleButton.attr('class') == "toggleOn"){
      	//animate toggle button position 
      	$(this).animate({'background-position': "186px -1px" }, 'fast');
      	$(this).removeClass('toggleOn');
      	$(this).addClass('toggleOff');
      	nsSend3("op=button","id=twitter_toggle", "state=on");
  		}
	});


	//My Fitness Pal Toggle Button
	me.$accountsContentBody.find("#myFitnessPalToggle").bind("mousedown." + me.name, function(e) {
       if(me.$myFitnessPalToggleButton.attr('class') == "toggleOff"){ 
       	//animate toggle button position
      	$(this).animate({'background-position': "117px -1px" }, 'fast');
      	//remove previous class
      	$(this).removeClass('toggleOff');
      	//assign new class
      	$(this).addClass('toggleOn');
      	//send message to OEM
      	nsSend3("op=button","id=fitnesspal_toggle", "state=off");
      }

      else if(me.$myFitnessPalToggleButton.attr('class') == "toggleOn"){
      	//animate toggle button position 
      	$(this).animate({'background-position': "186px -1px" }, 'fast');
      	$(this).removeClass('toggleOn');
      	$(this).addClass('toggleOff');
      	nsSend3("op=button","id=fitnesspal_toggle", "state=on");
  		}
	});
	
	return me;
};

// Internationalize text.
accountsObj.prototype.htmlInternationalString = function coreAccountsObjHtmlInternationalString() {
	var me = this;
	$('#accountsContentHeader').html(IDS_LANGUAGE.accounts["accountsContentHeader"]);
	return me;
};

// Get user data.
accountsObj.prototype.getData = function coreAccountsObjGetData() {
	var me = this;
	return me;
};

// Display user data.
accountsObj.prototype.displayData = function coreAccountsObjDisplayData() {
	var me = this;
	return me;
};

// Add functions to the end of the view.
accountsObj.prototype.postShowHook = function coreAccountsObjPostShowHook() {
	var me = this;
	return me;
};

// Clean-up view and hide.
accountsObj.prototype.hide = function coreAccountsObjHide() {
	var me = this;
	return me;
};

