/*=====================================================================
	Attract Script (CORE) | views/attract/js.js
=====================================================================*/

/* ATTRACT OBJECT CONSTRUCTOR ----------------------------- */

function attractObj(name, type, vm) {
    this.name = name;
    this.type = type;
    this.vm = vm;
}

//  Inherit basic view functions init(), preload(), load(), show(), hide()
attractObj.prototype = new app;

/* END ATTRACT OBJECT CONSTRUCTOR ------------------------- */


/* -------------------------------------------------------- */

attractObj.prototype.show = function() {
	doNetworkCheck();
	athleteObj.set_is_aboard(0);
	this.findHTMLElements();

    // If any client zones exist in this view, set them up.
    setupClientZones();

	this.htmlInternationalString();
    this.attachEvents();

	/* Since code for showing the config popup already exists in hera.js, creating an
		object to perform the same function seems unnecessay and actually causes some problems. 
		Let me know if I'm wrong! - MR */
	// this.configButton = new configButtonObj(this.$mainContainer.find("#configPopupButton"));

    this.showSupportInfo(machineObj.getMachineDemoNetwork());

    if(window.server_available)
        $('#id_my_workout').removeAttr('disabled').removeClass('disabled');

    this.showAds();
    return(true);
};

/* -------------------------------------------------------- */

attractObj.prototype.findHTMLElements = function() {
	//
	this.$mainContainer = $('div#id_attract_view');

	// Define dimmer OFF switch
	this.$dim = $("div#id_dim");

	// Define dimmer OFF switch
	this.$dim_off = this.$dim.find("button#id_dim_off");

	// Define dimmer ON switch
	this.$dim_on = this.$dim.find("button#id_dim_on");

	// Define dimmer screen
	this.$dim_screen = this.$dim.find("div#id_dim_screen");

	// Define language selection
	this.$select_language = this.$dim.find("button#select_language");

	//
	this.$quick_start = $("#id_quick_start");

	//
	this.$quick_start_label = $("#id_quick_start_label");

	//
	this.$screen_on = $("#id_screen_on");

	//
	this.$screen_off = $("#id_screen_off");

	//
	this.$my_language = $("#id_my_language");

	//
	this.$select_workout = $("#id_select_workout");

	//
	this.$my_workout = $("#id_my_workout");

	//
	this.$my_workout_label = $("#id_my_workout_label");
};

/* -------------------------------------------------------- */

attractObj.prototype.htmlInternationalString = function() {};

/* -------------------------------------------------------- */


/* NETWORK CHECK ------------------------------------------ */

function doNetworkCheck() {
	var serverUpUrl = machineObj.getServerLocation() + "n5iserverup.jsp?mid=" + configObj.getMid();
	dirtyHarry(serverUpUrl,
		function(data) { networkCheckSuccess(data); },
		function() { networkCheckFailed(); },
		null, 15000);
}

function networkCheckSuccess(data) {
	if ('ALIVE' == $(data).find("result").text()) {
		window.server_available = true;
		if ($('#id_my_workout').attr('disabled'))
			$('#id_my_workout').removeAttr('disabled').removeClass('disabled');
		$('.no_internet_connection').hide();
		var machineError = $(data).find("result").attr("error");
		window.machine_validated = (machineError == null || machineError.length == 0);
		writeLog("info", "Network check successful.");
	} else
		networkCheckFailed();

    if ('CSAFE_EMBEDDED' != workoutdataObj.get_csafe_application_state()) {
		if ($('#id_quick_start').attr('disabled'))
			$('#id_quick_start').removeAttr('disabled').toggleClass('disabled');
	}
}

function networkCheckFailed() {
	window.server_available = false;
	if (!$('#id_my_workout').attr('disabled'))
		$('#id_my_workout').attr('disabled', 'disabled').toggleClass('disabled');
	if (machineObj.getMachineDemoNetwork())
		$('.no_internet_connection').hide();
	else
		$('.no_internet_connection').show();
	writeLog("info", "Network check failed, trying again in 60 seconds.");
	clearTimeout(this.runNetworkCheck);
	if (viewManager.currentView) {
		if ('attract' == viewManager.currentView.name)
			this.runNetworkCheck = setTimeout(function runNetworkCheck1() { doNetworkCheck(); }, 60 * 1000);
	} else
		this.runNetworkCheck = setTimeout(function runNetworkCheck2() { doNetworkCheck(); }, 60 * 1000);
	if ('CSAFE_EMBEDDED' != workoutdataObj.get_csafe_application_state()) {
		if ($('#id_quick_start').attr('disabled'))
			$('#id_quick_start').removeAttr('disabled').toggleClass('disabled');
	}
}

/* END NETWORK CHECK -------------------------------------- */


/* SHOW ADS ----------------------------------------------- */

//
attractObj.prototype.showAds = function coreAttractObjShowAds() {
	adMan.showAd("sunburst");
	adMan.showAd("active_billboard");
};

//
attractObj.prototype.hideAds = function coreAttractObjHideAds() {
	adMan.showAd("sunburst");
	adMan.hideAd("active_billboard");
};

/* END SHOW ADS-------------------------------------------- */


/* LOGIN CLICKS ------------------------------------------- */

//
attractObj.prototype.goLogin = function coreAttractObjGoLogin() {
// If user is logged in, skip the login view
	if ('' != athleteObj.get_user_id())
		viewManager.show("landingPage");
	else {
        viewManager.nextView = "landingPage";
		viewManager.show("login");
	    nsLocal("op=sow");
	}
};

attractObj.prototype.goQuickStart = function coreAttractObjGoQuickStart() {
	nsLocal ("op=sow");
	viewManager.show("landingPage");
};

attractObj.prototype.goQuickStartNn = function coreAttractObjGoQuickStartNn() {
    nsLocal ("op=sow");
	viewManager.show("mainMenuNn");
};

/* END LOGIN CLICKS --------------------------------------- */


/* SECRET CODE TAP SEQUENCE ------------------------------- */

//	Allows the entry of a secret code on the attract screen.
function configButtonObj(button) {
	this.$button = button;
	this.correctClicks = 0;
	this.boxWidth = 200;
	this.init();
}

//	
configButtonObj.prototype.init = function coreConfigButtonObjInit() {
	var _this = this;
	this.$button.bind("mousedown", function(e) {
		_this.clicked(e);
		return (true);
	});
};

//	
configButtonObj.prototype.showPopup = function coreConfigButtonObjShowPopup() {
	showConfigPopup();
};

//	
configButtonObj.prototype.clicked = function coreConfigButtonObjClicked(e) {
	var x = e.pageX - this.$button.offset().left;

	this.correctClicks = (x < this.boxWidth) ? (this.correctClicks == 0 || this.correctClicks == 3) ? this.correctClicks + 1 : 1 : (x > this.$button.width() - this.boxWidth) ? (this.correctClicks == 1 || this.correctClicks == 2) ? this.correctClicks + 1 : 0 : 0;

	if (this.correctClicks >= 4) {
		this.showPopup();
		this.correctClicks = 0;
	}
};

/* END SECRET CODE TAP SEQUENCE --------------------------- */


/* SCREEN DIMMER ------------------------------------------ */

// Roll up dimmer screen
attractObj.prototype.unDim = function coreAttractObjUnDim() {
	var _this = this;
	_this.$dim_screen.css({ 'height' : '1px' });
	_this.$dim_off.show();
	_this.$dim_on.hide();
	clearTimeout(_this.dimTimeout);
};

// Roll down dimmer screen
attractObj.prototype.dim = function coreAttractObjDim() {
	var _this = this;
	_this.$dim_screen.css({ 'height' : '769px' });
	_this.$dim_off.hide();
	_this.$dim_on.show();
	_this.dimTimeout = setTimeout(
		function() { // Roll up dimmer screen after 30min(1800000ms) count-down
			_this.unDim();
		}, 1800000);
};

/* END SCREEN DIMMER -------------------------------------- */


/* SUPPORT INFO ------------------------------------------- */

//	
attractObj.prototype.showSupportInfo = function coreAttractObjshowSupportInfo(demo) {
	$("#id_hostname").html((('1' == demo) ? 'DEMO:':'') + configObj.getMid() + ':' + getVersion());
};

/* END SUPPORT INFO --------------------------------------- */


/* -------------------------------------------------------- */
/* END ---------------------------------------------------- */
