//
//  Menu view control.
//
function menuView(name, type, vm)
{
    this.name = name;
    this.type = type;
    this.vm = vm;

    this.items = new Array();
    this.itemsPerPage = 6;

    this.$menuContainer = null;
}

//  Inherit basic view functions init(), show(), hide()
menuView.prototype = new app;

menuView.prototype.init = function()
{
    this.items = new Array();
    this.buildItemsLists();

    //  If tv only, remove any items that require network

    var network = machineObj.getNetworkType();
    if("wired" != network.toLowerCase() && "wireless" != network.toLowerCase())
    {
        for(var i=0;i<this.items.length;i++)
            if(this.items[i].requiresNetwork)
            {
                this.items.splice(i, 1);
                i--;
            }
    }

    this.prepare();
}

menuView.prototype.buildItemsLists = function()
{
    this.items = new Array();

    //  menuItem(name, requiresNetwork, requiresEmbedded, onclick, hideWhenDisabled)
    this.items.push(new menuItem("tv", false, false, null, true));
    this.items.push(new menuItem("onDemand", true, false));
    this.items.push(new menuItem("music", true, false));
    this.items.push(new menuItem("ipod", false, false, null, true));
    this.items.push(new menuItem("workoutHistory", true, false));
    this.items.push(new menuItem("playlist", true, false));
}

//
//  Preload this page - it is drawn with javascript, so loading the html isn't good enough.
//
menuView.prototype.prepare = function()
{
    var $preloadContainer = $("#preloadDiv");

    var htmlStr = '' +
    '<div id="mainMenu">' +
        '<ul id="menuContainer"></ul>' +
    '</div>';

    $preloadContainer.append(htmlStr);

    var $menuContainer  = $preloadContainer.find("#menuContainer");

    //  Row 1
    for(var i=0;i<this.items.length;i++)
        $menuContainer.append(this.items[i].drawMe(false));

    $menuContainer.find("li").css("width", (100/this.items.length)+"%");
}

menuView.prototype.show = function() {
	try {
		this.buildItemsLists();
		this.buildMenuData();

		this.$menuContainer = $("#menuContainer");

		this.slidingBox = new slidingBox(this.menuData, $("#viewPort"), $("#menuContainer"), $("#backButton"), $("#nextButton"), 1, 200);

		this.showHookBeforeShow();
		this.htmlInternationalString();
		this.showAds();
		return true;
	} catch(e) {popError(e); return false; }
};

//Show TV view ads.
menuView.prototype.showAds = function coreMenuViewShowAds() { adMan.showAd("mm_300x250"); };

//Hide TV view ads.
menuView.prototype.hideAds = function coreMenuViewHideAds() { adMan.hideAd("mm_300x250"); };

menuView.prototype.showHookBeforeShow = function() {};

menuView.prototype.buildMenuData = function()
{
    this.menuData = new Array();
    this.menuData.levels = new Array();

    this.menuData.levels[0] = new Array();

    this.menuData.levels[0] = {

        drawItem :
            function(data)
            {
                return(data.drawMe());
            },

        attachEvents :
            function(obj, $container)
            {
                $container.find("li").each(function() {

                    $(this).bind("click", function() { 
						
                        // Call the init method again on the object
                        // to see if the app has initied itself 
                        // Not all methods are available in the object
                        // so we have to do some black magic to reinit the view.
                        var viewName = $(this).find(".nameValue").val();
						
                        var viewObj = viewManager.getNewView(viewName);
                        if (viewObj && viewObj.disabled) {
                            var tempObj = new viewObj.type(viewObj.name, viewObj.type, this, viewObj.superClass);
                            if (tempObj.init) {
                                tempObj.init();
                            }
                            if (tempObj.disabled) {
                                showModal("disabled", true);
                            }
                            delete tempObj;
                            tempObj = null;
                        }
                        else {
                            viewManager.show(viewName);
                        }
                    });
                });
            },

        itemsPerPage : this.itemsPerPage

    };

    this.menuData.items = this.items;
};

menuView.prototype.htmlInternationalString = function menuViewHtmlInternationalString() {};


