//  OnDemand View Object
function ondemandObj(name, type, vm) {
	this.name = name;
	this.type = type;
	this.vm = vm;
	this.itemsPerPage = 6;
	this.volume = machineObj.getVolumeLevel();
	this.startTime = 0;
	this.endTime = 0;
	this.videoPlaying = false; 
	this.disabled = false;
	
	// Menu Item Ad Banner.
	this.showMenuAdBanner = false;
	this.menuAdBannerName = 'ondemand_btn_branded';
    this.slidingExit = function slidingExit() { viewManager.show('mainMenu'); };
}

// inherit base app prototype
ondemandObj.prototype = new app;

// Init() - if mediaXML is null (not found), disable this page.
ondemandObj.prototype.init = function coreOndemandObjInit() {
	var me = this;

	if (mediaXML == null)
		me.disabled = true;

	return me;
};

// Show()
ondemandObj.prototype.show = function coreOndemandObjShow() {
	var me = this;

	try {
		if (!me.data)
			me.getData();

		me.bindHTMLElements();

		me.bindSkinSpecificElements();

		me.buildLevelsArray();

		me.buildSlideBox();

		me.attachEvents();

		me.insertBrandedMenuItem();

        me.htmlInternationalString();

		$("#videoBackground").hide();

		return true;

	} catch (e) { popError(e); return false; }
};

ondemandObj.prototype.getBrandedMenuData = function coreOndemandObjGetBrandedMenuData() {
	var me = this, firstDataItem = me.data.items[0];

	me.showMenuAdBanner = adMan.showAd(me.menuAdBannerName);

	if (true == me.showMenuAdBanner && !(firstDataItem.type == 'ad')) {
		var brandedMenuAdPlaceholder = {
			items : [],
			shuffle : false,
			thumbnail : '',
			title : me.menuAdBannerName,
			type : 'ad'
		};
		me.data.items.splice(0, 0, brandedMenuAdPlaceholder);
	} else if (!me.showMenuAdBanner && (firstDataItem.type == 'ad')) {
		me.data.items.splice(0, 1);
	}

	return me;
};

ondemandObj.prototype.insertBrandedMenuItem = function coreOndemandObjInsertBrandedMenuItem() {
	var me = this;

    // Make use of the branded banner in the data object
    if (me.showMenuAdBanner) {
    	me.$placeHolder = $("#level_0_item_0").addClass('ad');
	    var $clone = $("#" + me.menuAdBannerName).clone(true, true).attr('id', me.menuAdBannerName + '_clone');
    	$clone.find('div').addClass('item');
    	me.$placeHolder.find('div').addClass('hidden');
    	me.$placeHolder.unbind().append($clone);
    }

	return me;
};

//
ondemandObj.prototype.getData = function coreOndemandObjGetData() {
    var dataItems = [];
    this.data = {
        // Fill data.items using mediaXML.onDemand or [].
        items : ( (mediaXML.onDemand) ? (dataItems.concat(mediaXML.onDemand) || dataItems) : dataItems )
    };
    this.getBrandedMenuData();
    return(this.data);
};

//
ondemandObj.prototype.bindSkinSpecificElements = function() {
	var me = this;
	return me;
};

//
ondemandObj.prototype.bindHTMLElements = function show() {
	var me = this;

	me.$container = $("#onDemand");
	me.$title = me.$container.find("h1");
	me.$videoContainer = me.$container.find("#videoContainer");
	me.$slidingViewPort = me.$container.find("#slidingViewPort");
	me.$viewPort = me.$container.find("#viewPort");
	me.$vidBrowser = me.$container.find("#vidBrowser");
	me.$backButton = me.$container.find("#backButton");
	me.$nextButton = me.$container.find("#nextButton");
	me.$menuTray = me.$container.find("#menuTray");
	me.$menuUserInfo = me.$menuTray.find("#userInfo");
	me.$menuItems = me.$menuTray.find("#items");
	me.$backToBrowsingButton = me.$videoContainer.find("#backToBrowsing");
	me.$nextVideoButton = me.$videoContainer.find("#nextVideo");
	me.$prevVideoButton = me.$videoContainer.find("#prevVideo");

	/* Volume Ctrl */
	me.$volUpButton = me.$container.find("#VolUpButton");
	me.$volDnButton = me.$container.find("#VolDnButton");

	return me;
};

//
ondemandObj.prototype.buildSlideBox = function() {
	var me = this;

	me.slideBox = new slidingBox(
		me.data,
		me.$viewPort,
		me.$vidBrowser,
		me.$backButton,
		me.$nextButton,
		1,
		200,
		this.slidingExit,
		$("#cueContainer")
	);

	return me;
};

function onDemandSlidingBox(data, $window, $slidingBox, $backButton, $nextButton, itemsToScroll, parallaxWidth, backButtonOnTop, $cueContainer, hidePagination) {
    this.data = data;
    this.$window = $window;
    this.$box = $slidingBox;
    this.$back = $backButton;
    this.$next = $nextButton;
    this.itemsToScroll = itemsToScroll;
    this.parallaxWidth = parallaxWidth;
    this.backButtonOnTop = backButtonOnTop;
    this.$cueContainer = ($cueContainer) ? $cueContainer : false;
    this.currentPage = 0;
    this.hidePagination = hidePagination;

    //  Get the initial left position
    this.currentLeft = new Number(parseInt(this.$box.css("left")));
    this.currentLevel = 0;
    this.chosenItems = [];
    this.savedLefts = [];

    this.scrollSpeed = 500;

    this.attachEvents();
    this.drawLevel(0);
};

ondemandObj.prototype.buildTitle = function coreOndemandObjBuildTitle(newTitle) {
	var me = this;

	me.$title.html(newTitle);

	return me;
};

ondemandObj.prototype.attachEvents = function() {
	var me = this;

	me.$backToBrowsingButton.bind("click." + me.name, function() {
		me.stopVideo();
		me.buildTitle("<strong>" + IDS_LANGUAGE.register["ondemandString"] + "</strong><em> - " + me.slideBox.data.items[me.slideBox.chosenItems[0]].items[me.slideBox.chosenItems[1]].title + "</em>");
	});

	me.$nextVideoButton.bind("click." + me.name, function() { me.nextVideo(); });
	me.$prevVideoButton.bind("click." + me.name, function() { me.prevVideo(); });

	return me;
};

//
// Set up levels array for slidingBox
//
ondemandObj.prototype.buildLevelsArray = function() {
	var me = this;

	me.data.levels = [];

	me.data.levels[0] = {
		drawItem : function(data) {
			me.buildTitle("<strong>" + IDS_LANGUAGE.register["ondemandString"] + "</strong>");
			
			if (data.title == "TV Shows") {
				return ("<div class='menu_button'><div style='background-image:url(../views/onDemand/images/tv.png)' class='item'></div><h2>" + data.title + "</h2></div>");
			} else if (data.title == "YouTube") {
				return ("<div class='menu_button'><div style='background-image:url(../views/onDemand/images/youTube.png)' class='item'></div><h2>" + data.title + "</h2></div>");
			} else if (data.title == "ReelzChannel") {
				return ("<div class='menu_button'><div style='background-image:url(../views/onDemand/images/reelz.png)' class='item'></div><h2>" + data.title + "</h2></div>");
			} else if (data.title == "Classic TV") { //added by Isabelle 3/2/2012
				return ("<div class='menu_button'><div style='background-image:url(../views/onDemand/images/classicTv.png)' class='item'></div><h2>" + data.title + "</h2></div>");
			} else if (data.title == "News and Entertainment") {
				return ("<div class='menu_button'><div style='background-image:url(../views/onDemand/images/news.png)' class='item'></div><h2>" + data.title + "</h2></div>");
			} else if (data.title == "Classic TV") { //added by Isabelle 3/2/2012
				return ("<div class='menu_button'><div style='background-image:url(../views/onDemand/images/classicTv.png)' class='item'></div><h2>" + data.title + "</h2></div>");
			} else if (data.title == "Sports and Travel") {
				return ("<div class='menu_button'><div style='background-image:url(../views/onDemand/images/sports.png)' class='item'></div><h2>" + data.title + "</h2></div>");
			} else if (data.title == "Video Game Trailers") { //Added by Vlad @Noah 11/9/11
				return ("<div class='menu_button'><div style='background-image:url(../views/onDemand/images/video_game_trailers.png)' class='item'></div><h2>" + data.title + "</h2></div>");
			} else if (data.title == "ondemand_btn_branded") {
				return ("<div class='menu_button ad ondemand_btn_branded'><!--//--></div>");
			} else if ((data.title).search("Movie Trailers") != -1) {
				return ("<div class='menu_button'><div style='background-image:url(../views/onDemand/images/starSpot.png)' class='item'></div><h2>" + data.title + "</h2></div>");
			} else {
				return ("<div class='menu_button'><div style='background-image:url(" + data.thumbnail + ")' class='item'></div><h2>" + data.title + "</h2></div>");
			}
		},
		itemsPerPage : me.itemsPerPage,
		scrollBack : function(e) {
			me.scrollBack(e);
		},
		scrollNext : function(e) {
			me.scrollNext(e);
		},
		attachEvents : function(slideBox, $box) {
			me.updateScrollButtonLabels(slideBox);
			me.attachChannelEvents(slideBox);
		}
	};

	me.data.levels[1] = {
		drawItem : function(data) {
			me.buildTitle("<strong>" + IDS_LANGUAGE.register["ondemandString"] + "</strong><em> - " + me.slideBox.data.items[me.slideBox.chosenItems[0]].title + "</em>");
			return ("<div class='menu_button'><div style='background-image:url(" + data.thumbnail + ")' class='item'></div><h2>" + ((data.title.length<=45) ? data.title : data.title.slice(0,42)+"...") + "</h2></div>");
		},
		attachEvents : function(slideBox, $box) {
			me.updateScrollButtonLabels(slideBox);
			slideBox.attachEventsDefault();
		},
		itemsPerPage : me.itemsPerPage,
		scrollBack : function(e) {
			me.scrollBack(e);
			me.getBrandedMenuData();
			me.insertBrandedMenuItem();
		},
		scrollNext : function(e) {
			me.scrollNext(e);
		}
	};

	me.data.levels[2] = {
		drawItem : function(data) {
			me.buildTitle("<strong>" + IDS_LANGUAGE.register["ondemandString"] + "</strong><em> - " + me.slideBox.data.items[me.slideBox.chosenItems[0]].items[me.slideBox.chosenItems[1]].title + "</em>");
			return ("<div class='menu_button'><div style='background-image:url(" + data.thumbnail + ")' class='item'></div><h2>" + ((data.title.length<=45) ? data.title : data.title.slice(0,42)+"...") + "</h2></div>");
		},
		attachEvents : function(slideBox, $box) {
			me.updateScrollButtonLabels(slideBox);

			$box.find("li").each(function() {
				var val = new Number($(this).find(".item_id").val());

				if (val >= 0) {
					$(this).bind("click." + me.name, function() {
						me.updateScrollButtonLabels(slideBox, true);
						var val = new Number($(this).find(".item_id").val());
						me.play();
					});
				}
			});
		},
		itemsPerPage : me.itemsPerPage,
		scrollBack : function(e) {
			me.scrollBack(e);
		},
		scrollNext : function(e) {
			me.scrollNext(e);
		}
	};

	return me;
};

//
ondemandObj.prototype.attachChannelEvents = function(slideBox) {
	var me = this;
	
	slideBox.$box.find("li").bind("click", function() {
		var $li = $(this), val = new Number($li.find(".item_id").val());
		if (slideBox.data.items[slideBox.chosenItems[0]].shuffle)
			me.playChannel();
		else
			slideBox.drawNextLevel();
	});

	return me;
};

//
// If a video is playing when the user hits the scroll back button, stop the video and DONT scroll back.
//
ondemandObj.prototype.scrollBack = function(e) {
	var me = this;

	if (me.videoPlaying) {
		me.stopVideo();
		return false;
	} 

	me.slideBox.scrollBack();
	me.updateScrollButtonLabels(me.slideBox);

	return me;
};

//
ondemandObj.prototype.scrollNext = function(e) {
	var me = this;

	if (me.videoPlaying) {
		me.stopVideo();
		return false;
	}

	me.slideBox.scrollNext();
	me.updateScrollButtonLabels(me.slideBox);

	return me;
};

//
ondemandObj.prototype.updateScrollButtonLabels = function(slideBox, playing) {
	if (playing)
		return;

	var me = this;
	var htmlStr = "";
	var $p = me.$backButton.find("p").css("opacity", "0");

	switch (slideBox.currentLevel) {
	case 0:
		htmlStr = (slideBox.currentLeft >= 0) ? "Menu" : "Back";
		break;

	case 1:
		htmlStr = (slideBox.currentLeft >= 0) ? "Channels" : "Back";
		break;

	case 2:
		htmlStr = (slideBox.currentLeft >= 0) ? slideBox.data.items[slideBox.chosenItems[0]].title : "Back";
		break;

	default:
		break;
	}

	setTimeout(function() {
		$p.html(htmlStr).css("opacity", "1");
	}, 150);

	return me;
};

//
ondemandObj.prototype.playChannel = function() {
	var me = this;
	me.slideBox.chosenItems[1] = 0;
	me.slideBox.chosenItems[2] = 0;

    var currentChannel = me.slideBox.data.items[me.slideBox.chosenItems[0]];
    if (currentChannel.shuffle)
        currentChannel.items[me.slideBox.chosenItems[1]].items.sort(randOrd);
	me.play();
};

//
ondemandObj.prototype.play = function() {
	var me = this;
	
	$("#videoBackground").show();
	
	if (me.errorTimeout)
		clearTimeout(me.errorTimeout);
        
	stopVideo(me.$videoContainer);
	
	var currentShow = me.slideBox.data.items[me.slideBox.chosenItems[0]].items[me.slideBox.chosenItems[1]];
	var currentEpisode = currentShow.items[me.slideBox.chosenItems[2]];

	me.buildTitle("<strong>" + IDS_LANGUAGE.register["ondemandString"] + "</strong><em> - " + currentShow.title + " - " + currentEpisode.title + "</em>");

	var playerString = '<object type="video/mpeg" id="videoPlayer" data="'
			+ currentEpisode.location
			+ '"><param name="allowScriptAccess" value="always"><param name="wmode" value="transparent"><param name="data_type" value="ondemand"></object>';

	if (me.playTimeout)
		clearTimeout(me.playTimeout);

	me.playTimeout = setTimeout(function() {
		playVideo(me.$videoContainer, playerString);
		me$videoPlayer = $('object#videoPlayer');
		me$videoPlayer.css({'width':'99%'});
		me$videoPlayer.css({'width':'100%'});
	}, 500);


	me.videoPlaying = true;

};

//
ondemandObj.prototype.mediaError = function() {
	var me = this;

	if (me.errorTimeout)
		clearTimeout(me.errorTimeout);

	me.killVideo();

	me.$videoContainer.append(IDS_LANGUAGE["videoUnavilable"]);

	me.errorTimeout = setTimeout(function() {
		me.nextVideo();
	}, 3 * 1000);
};

ondemandObj.prototype.stopVideo = function() {
	var me = this;
	
	me.killVideo();

	if (me.errorTimeout)
		clearTimeout(me.errorTimeout);
};

ondemandObj.prototype.killVideo = function() {
	if (!this.$videoContainer)
		return;

	stopVideo(this.$videoContainer);

	this.videoPlaying = false;
};

ondemandObj.prototype.getCurrentVideoId = function()
{
	
    var currentShow = this.slideBox.data.items[this.slideBox.chosenItems[0]].items[this.slideBox.chosenItems[1]];
	var currentEpisode = currentShow.items[this.slideBox.chosenItems[2]];

    return(currentEpisode.id);
};

ondemandObj.prototype.nextVideo = function() {
	var me = this,
		currentShow = me.slideBox.data.items[me.slideBox.chosenItems[0]].items[me.slideBox.chosenItems[1]];

	this.saveImpression();	
	me.slideBox.chosenItems[2] = (parseInt(me.slideBox.chosenItems[2]) >= currentShow.items.length - 1) ? 0 : parseInt(me.slideBox.chosenItems[2]) + 1;
	me.play();
};

ondemandObj.prototype.prevVideo = function() {
	var me = this,
		currentShow = me.slideBox.data.items[me.slideBox.chosenItems[0]].items[me.slideBox.chosenItems[1]];
	this.saveImpression();
	me.slideBox.chosenItems[2] = (parseInt(me.slideBox.chosenItems[2]) == 0) ? currentShow.items.length - 1 : parseInt(me.slideBox.chosenItems[2]) - 1;
	me.play();
};

ondemandObj.prototype.hide = function() {
	$("#videoBackground").hide();
	this.stopVideo();
};

ondemandObj.prototype.showVideoAd = function() { };


ondemandObj.prototype.disableChannelControls = function()
{
	$("#previousVideo").attr("disabled","true");
	$("#nextVideo").attr("disabled","true");
	$("#previousVideo").css("opacity","0.5");
	$("#nextVideo").css("opacity","0.5");
};

ondemandObj.prototype.enableChannelControls = function()
{
	$("#previousVideo").attr("disabled",false);
	$("#nextVideo").attr("disabled",false);
	$("#previousVideo").css("opacity","1.0");
	$("#nextVideo").css("opacity","1.0");
};

ondemandObj.prototype.saveImpression = function()
{
	var playTime = guiObj.getVideoTimeElapsedInSeconds();
	
	if(playTime <= 0)
		return;

	if (adMan.ads['ondemand_preroll_video'].videoBool) {
		if (viewManager.currentView.name == 'onDemand') {
			adMan.ads['ondemand_preroll_video'].addVideoImpression(playTime);
		}
		guiObj.resetVideoTimeElapsedInSeconds();
		return;
	}
  
	var impression = new mediaImpression(this.getCurrentVideoId(), playTime);
	impressions.addImpression(impression);
	
	guiObj.resetVideoTimeElapsedInSeconds();
};

ondemandObj.prototype.htmlInternationalString = function()
{
	var me = this;
	$('#more').html(IDS_LANGUAGE["more"]);
	me.$title.find("strong").html(IDS_LANGUAGE.register["ondemandString"]);
};

ondemandObj.prototype.sortByLatestContent = function (){
	//It will sort the Ondemand content by placing latest content on the top.
	
	var me = this;
	var onDemandContent = me.data.items;
	
	for(var k=0; k<onDemandContent.length; k++){
		for(var j=0;j<onDemandContent[k].items.length;j++)
	    {
	        if(onDemandContent[k].items[j].items)
	        {       
	            for(var i=0; i < onDemandContent[k].items[j].items.length; i++)
	            	onDemandContent[k].items[j].items.sort(sortonDemandContentById);
	        }
	    }
	    	
		onDemandContent[k].items.sort(sortonDemandContentByTopId);
	}
};

function sortonDemandContentById(a,b)
{  //Sorts episodes by placing latest episodes on the top.
    return (( parseInt(a.id) > parseInt(b.id)) ? -1 : ((parseInt(a.id) < parseInt(b.id)) ? 1 : 0));
};

function sortonDemandContentByTopId(a, b)
{//sorts Shows by placing Shows that have latest content on the top.
	return ((parseInt(a.items[0].id) > parseInt(b.items[0].id)) ? -1 : ((parseInt(a.items[0].id) < parseInt(b.items[0].id)) ? 1 : 0));    
}
