/*=====================================================================
	startupVideo Script (CORE) | views/startupVideo/js.js
=====================================================================*/

function startupVideoObj(name, type, vm) {
    this.name = name;
    this.type = type;
    this.vm = vm;
    
    this.startupVideoPlayed = false;
    this.volume = machineObj.getVolumeLevel();
    this.disableVLCFullscreen = true;
    this.stdVolDiff = 5;
}

//  Inherit basic view functions init(), preload(), load(), show(), hide()
startupVideoObj.prototype = new app;

startupVideoObj.prototype.show = function coreStartupVideoObjShow() {
	try {
		// Add functions to the beginning of the view.
		this.preShowHook();
		// Find DOM elements.
		this.bindHTMLElements();
		// Bind listeners to DOM elements.
		this.attachEvents();
		//Shows/Plays startup Video
		this.showAds();
		// Internationalize text.
		this.htmlInternationalString();
		// Add functions to the end of the view.
		this.postShowHook();
	} catch (e) {
		popError(e);
		return false;
	}
	return true;
};

startupVideoObj.prototype.preShowHook = function coreStartupVideoObjPreShowHook() {};

startupVideoObj.prototype.bindHTMLElements = function coreStartupVideoObjBindHTMLElements() {
    // Bind listeners to DOM elements.
	this.$mainContainer = $("#startupVideoView");
	this.$volumeUpButton = this.$mainContainer.find("#volume #volUpButton");
	this.$volumeDnButton = this.$mainContainer.find("#volume #volDnButton");
	this.$continueButton = this.$mainContainer.find("#continue #continueButton");
	this.$videoPlayer = this.$mainContainer.find("#videoContainer");
};

startupVideoObj.prototype.nextVideo = function coreStartupVideoObjNextVideo() {
	try {
		this.saveImpression();
	} catch (e) { popError(e); }
	stopVideo($("#startupVideoContainer"));
	setTimeout(function() {viewManager.showNextView();}, 200);
};

startupVideoObj.prototype.attachEvents = function coreStartupVideoObjAttachEvents() {
	var me = this;
	
	me.$volumeUpButton.bind("mousedown", function () { //increase volume
		me.volumeUp();
		});
	
	me.$volumeDnButton.bind("mousedown", function () { //increase volume
		me.volumeDown();
		});
	
	me.$continueButton.bind("mousedown", function () {
		me.nextVideo();
	});
};

startupVideoObj.prototype.showAds = function coreStartupVideoObjShowAds() {
    //Shows/Plays startup Video
    var showStartupVideo = adMan.showAd("startup_video");
    if (showStartupVideo) {
        adMan.showAd("startup_bg");
    } else {
        viewManager.showNextView();
    }
};

startupVideoObj.prototype.volumeUp = function coreStartupVideoObjVolumeUp() {
	this.volume = this.volume + this.stdVolDiff;
	if (this.volume <= 100) {
		setVolume("ondemand", String(this.volume));
	} else {
		this.volume = 100;
	}
};

startupVideoObj.prototype.volumeDown = function coreStartupVideoObjVolumeDown() {
	this.volume = this.volume - this.stdVolDiff;
	if (this.volume >= 0) {
		setVolume("ondemand", String(this.volume));
	} else {
		this.volume = 0;
	}
};

startupVideoObj.prototype.htmlInternationalString = function coreStartupVideoObjHtmlInternationalString() {
    // Internationalize text.
	this.$continueButton.find("span").html(IDS_LANGUAGE["continue"]);
	$("#videoProgress #timeLeft").html(IDS_LANGUAGE["advertisement"] + ": ");
};

startupVideoObj.prototype.saveImpression = function coreStartupVideoObjSaveImpression() {
	var playTime = guiObj.getVideoTimeElapsedInSeconds();

	if(playTime > 0)
		adMan.ads["startup_video"].addVideoImpression(playTime);
	
	guiObj.resetVideoTimeElapsedInSeconds();
};

startupVideoObj.prototype.postShowHook = function coreStartupVideoObjPostShowHook() {};